class BUTTON_DEMO_FORM_EVENT_HANDLER
   
inherit
   FORM_MANAGER_CLIENT
   CONTROLS_CONSTANTS
   STANDARD_EVENT_HANDLER   
      redefine
	 handle_frm_open_event,
	 handle_ctl_select_event,
	 handle_ctl_repeat_event
      end
	 
feature {ANY}
   
   handle_frm_open_event( event : EVENT ) is
      local
	 form : FORM
      do
	 form := form_manager.active_form
	 form.draw
	 set_label_as_integer( form, Button_demo_reg_label, 50 )
	 set_label_as_integer( form, Button_demo_rpt_label, 50 )
	 set_label_as_integer( form, Button_demo_pushbutton_label, 1 )
	 form.set_control_group_selection_by_id( 1, Button_demo_pushbutton_a )
	 last_event_was_handled := True
      end
   
   handle_ctl_select_event( event : EVENT ) is
      do
	 inspect 
	    event.data_ctlselect_controlid
	 when Button_demo_reg_dec_button then
	    decrement_reg_label( form_manager.active_form )
	 when Button_demo_reg_inc_button then
	    increment_reg_label( form_manager.active_form )
	 when Button_demo_pushbutton_a then
	    reset_pushbutton_group( form_manager.active_form )
	 when Button_demo_pushbutton_b then
	    reset_pushbutton_group( form_manager.active_form )	    
	 when Button_demo_pushbutton_c then
	    reset_pushbutton_group( form_manager.active_form )
	 when Button_demo_pushbutton_d then
	    reset_pushbutton_group( form_manager.active_form )
	 when Button_demo_pushbutton_e then
	    reset_pushbutton_group( form_manager.active_form )
	 when Button_demo_back_button then
	    form_manager.return_to_form( Controls_main_form )
	 else
	 end
	 last_event_was_handled := True
      end

   handle_ctl_repeat_event( event : EVENT ) is
      do
	 inspect
	    event.data_ctlrepeat_controlid
	 when Button_demo_rpt_dec_button then
	    decrement_rpt_label( form_manager.active_form )
	 when Button_demo_rpt_inc_button then
	    increment_rpt_label( form_manager.active_form )
	 else
	 end
      end
	 
   reset_pushbutton_group( form : FORM ) is
      do
	 set_label_as_integer( form, Button_demo_pushbutton_label, form.control_group_selection( 1 ) - 7)
      end
   
   label_as_integer( form : FORM; label_id : INTEGER_16 ) : INTEGER_16 is
      local
	 field : FORM_FIELD
      do
	 field := form.field_from_id( label_id );
	 Result := field.contents.to_integer.to_integer_16
      end
   
   set_label_as_integer( form : FORM; label_id, new_label : INTEGER_16 ) is
      local
	 field : FORM_FIELD
      do
	 field := form.field_from_id( label_id )
	 field.set_text_to_string( new_label.to_string )
	 field.draw
      end
   
   decrement_reg_label( form : FORM ) is
      do
	 set_label_as_integer( form, Button_demo_reg_label,
			       (label_as_integer( form, Button_demo_reg_label) - 1).max( 0 ) )
      end
   
   increment_reg_label( form : FORM ) is
      do
	 set_label_as_integer( form, Button_demo_reg_label,
			       (label_as_integer( form, Button_demo_reg_label) + 1).min(99))
      end
   
   decrement_rpt_label( form : FORM ) is
      do
	 set_label_as_integer( form, Button_demo_rpt_label,
			       (label_as_integer( form, Button_demo_rpt_label) - 1).max( 0 ) )
      end
   
   increment_rpt_label( form : FORM ) is
      do
	 set_label_as_integer( form, Button_demo_rpt_label,
			       (label_as_integer( form, Button_demo_rpt_label) + 1).min(99))
      end
   
   
end
   
