class FIELD_DEMO_FORM_EVENT_HANDLER
   
inherit
   PALM_CHARS
   FORM_MANAGER_CLIENT
   CONTROLS_CONSTANTS
   STANDARD_EVENT_HANDLER
      redefine
	 handle_frm_open_event,
	 handle_ctl_select_event,
	 handle_fld_changed_event,
	 handle_scl_repeat_event,
	 handle_key_down_event
      end
	 
feature {ANY} 
   
   handle_frm_open_event( event : EVENT ) is
      do
	 form_manager.active_form.draw
	 update_big_field(form_manager.active_form)
	 last_event_was_handled := True
      end
   
   handle_ctl_select_event( event : EVENT ) is
      do
	 inspect event.data_ctlselect_controlid
	 when Field_demo_convert_button then
	    convert_dec_to_hex( form_manager.active_form )
	    last_event_was_handled := True
	 when Field_demo_reverse_button then
	    reverse_field( form_manager.active_form )
	    last_event_was_handled := True
	 when Field_demo_back_button then
	    form_manager.return_to_form( Controls_main_form )
	    last_event_was_handled := True
	 else
	    last_event_was_handled := False
	 end
      end
   
   handle_fld_changed_event( event : EVENT ) is 
      do
	 if event.data_fldchanged_fieldid = Field_demo_big_field then
	    update_big_field( form_manager.active_form )
	    last_event_was_handled := True;
	 else
	    last_event_was_handled := False
	 end
      end
   
   handle_scl_repeat_event( event : EVENT ) is
      do
	 if event.data_sclrepeat_scrollbarid = Field_demo_scrollbar then
	    scroll_big_field( form_manager.active_form, event.data_sclrepeat_newvalue - event.data_sclrepeat_value )
	 end
      end
   
   handle_key_down_event( event : EVENT ) is
      do
	 if event.data_keydown_chr = Page_up_chr then
	    form_manager.active_form.field_from_id( Field_demo_big_field ).scroll_pages( -1 )
	    update_big_field( form_manager.active_form )
	    last_event_was_handled := True;
	 elseif event.data_keydown_chr = Page_down_chr then
	    form_manager.active_form.field_from_id( Field_demo_big_field ).scroll_pages( 1 )
	    update_big_field( form_manager.active_form )
	    last_event_was_handled := True;
	 end
      end
   
   scroll_big_field( form : FORM; lines_to_scroll : INTEGER ) is
      do
	 form.field_from_id( Field_demo_big_field ).scroll( lines_to_scroll.to_integer_16 )
	 update_big_field( form )
      end
   
   update_big_field( form : FORM ) is
      local
	 field : FORM_FIELD
	 scrollbar : FORM_SCROLLBAR
      do
	 field := form.field_from_id( Field_demo_big_field )
	 scrollbar := form.scrollbar_from_id( Field_demo_scrollbar )
	 scrollbar.set_scrollbar_values( field.scrollbar_values )
      end
   
   
   convert_dec_to_hex( form: FORM ) is
      local
	 new_contents : STRING
	 source_field, target_field : FORM_FIELD
      do
	 source_field := form.field_from_id( Field_demo_dec_field )
	 target_field := form.field_from_id( Field_demo_hex_field )
	 new_contents := source_field.contents.to_integer.to_hexadecimal
	 target_field.set_text_to_string( new_contents )
	 target_field.draw
      end
   
   reverse_field( form : FORM ) is
      local
	 contents : STRING
	 field : FORM_FIELD
      do
	 field := form.field_from_id( Field_demo_reverse_field )
	 contents := field.contents
	 contents.reverse
	 field.set_text_to_string( contents )
	 field.draw
      end
end

	    
