class MEMORY_DEMO_FORM_EVENT_HANDLER
   
inherit
   MEMORY
   FORM_MANAGER_CLIENT
   CONTROLS_CONSTANTS
   STANDARD_EVENT_HANDLER
      redefine
	 handle_frm_open_event,
	 handle_ctl_select_event
      end
	 
feature {ANY} 
   
   handle_frm_open_event( event : EVENT ) is
      do
	 form_manager.active_form.draw
	 last_event_was_handled := True
      end
   
   handle_ctl_select_event( event : EVENT ) is
      do
	 inspect event.data_ctlselect_controlid
	 when Memory_demo_allocate_button then
	    allocate_memory( form_manager.active_form )
	    last_event_was_handled := True
	 when Memory_demo_collect_button then
	    collect( form_manager.active_form )
	    last_event_was_handled := True
	 when Memory_demo_back_button then
	    form_manager.return_to_form( Controls_main_form )
	    last_event_was_handled := True
	 else
	    last_event_was_handled := False
	 end
      end
   
   last_heap_id : INTEGER_16
   
   allocate_memory( form : FORM ) is 
      local
	 new_handle : MEM_HANDLE
      do
	 create new_handle.allocate( form.field_from_id( Memory_demo_allocate_size_field ).contents.to_integer, True )
	 show_heap_status( form, last_heap_id )
      end
	 
   show_heap_status( form : FORM; heap_id : INTEGER_16 ) is
      local
	 id_field : FORM_FIELD
	 free_field : FORM_FIELD
	 heap : MEM_HEAP
      do
	 last_heap_id := heap_id
	 id_field := form.field_from_id( Memory_demo_heap_id_field )
	 id_field.set_text_to_string( heap_id.to_string )
	 id_field.draw
	 
	 create heap.from_id( heap_id )
	 free_field := form.field_from_id( Memory_demo_free_bytes_field )
	 free_field.set_text_to_string( heap.free_bytes.to_string )
	 free_field.draw
      end
   
   collect( form : FORM ) is 
      do
	 full_collect
	 show_heap_status( form, last_heap_id )
      end
   
end

	 
