class TRIGGER_DEMO_FORM_EVENT_HANDLER
   
inherit
   FORM_MANAGER_CLIENT
   CONTROLS_CONSTANTS
   STANDARD_EVENT_HANDLER
      redefine
	 handle_frm_open_event,
	 handle_ctl_select_event,
	 handle_pop_select_event,
	 handle_lst_select_event
      end
	 
feature {ANY}	 
   
   handle_frm_open_event( event : EVENT ) is
      do
	 form_manager.active_form.field_from_id( Trigger_demo_form_regular_list_field ).set_text_to_string( "Unix" )
	 form_manager.active_form.draw
	 last_event_was_handled := True
      end
   
   handle_ctl_select_event( event : EVENT ) is
      do
	 if event.data_ctlselect_controlid = Trigger_demo_back_button then
	    form_manager.return_to_form( Controls_main_form )
	    last_event_was_handled := True
	 end
      end
   
   handle_pop_select_event( event : EVENT ) is
      do
	 inspect event.data_popselect_controlid
	 when Trigger_demo_form_popup_trigger then
	    set_popup_trigger_field( form_manager.active_form, event.data_popselect_list, event.data_popselect_selection )
	    last_event_was_handled := True
	 else
	 end
      end
   
   handle_lst_select_event( event : EVENT ) is
      do
	 if event.data_listselect_listid = Trigger_demo_form_regular_list then
	    set_regular_list_field( form_manager.active_form, event.data_listselect_list, event.data_listselect_selection )
	    last_event_was_handled := True
	 end
      end   
   
   set_popup_trigger_field( form : FORM;
									 list : FORM_LIST;
									 selection : INTEGER_16 ) is
      local
	 field : FORM_FIELD
      do
	 field := form.field_from_id( Trigger_demo_form_popup_field )
	 field.set_text_to_string( list.selection_text( selection ) )
	 field.draw
      end
   
   set_regular_list_field( form : FORM; list : FORM_LIST; selection : INTEGER_16 ) is
      local
	 field : FORM_FIELD
      do
	 field := form.field_from_id( Trigger_demo_form_regular_list_field )
	 field.set_text_to_string( list.selection_text( selection ) )
	 field.draw
      end
   
end
   
