
class DATABASE_DEMO

inherit
   DATABASE_DEMO_CONSTANTS
   FORM_DISPATCHER_CLIENT
   PALM_APPLICATION
      redefine
         handle_event, start_application
      end
   DATABASE_MANAGER_CLIENT


creation
   pilot_main

feature {ANY} -- redefined application features
   
   application_database : APPLICATION_DATABASE
   
   application_database_opened_successfully : BOOLEAN
   
   open_application_database is
	 --tries to open main database.  If this fails, creates the 
	 --database and then opens it
      do
	 create application_database.from_type_and_creator_using_characters( 'd', 'e', 'm', 'o',
									     'e', 'p', 'l', 'm',
									     "Database_demo",
									     3 )
      end
   
   
   start_application is
	 --opens main form and opens/creates database
      do
	 open_application_database
         create form_handler.make( application_database )
         form_manager.go_to_form( Main_form )
      end

   handle_event( event : EVENT ) is
      --handle PalmOS events
      local
         form : FORM
      do
         inspect event.type
         when Frm_load_event then
            create form.from_form_id( event.data_frmload_formid )
            form.set_as_active_form
            form.set_event_handler( form_handler )
            last_event_was_handled := True
         else
            last_event_was_handled := False
         end
      end

   form_handler : MAIN_FORM_EVENT_HANDLER

end -- class DATABASE_DEMO
