class DEMO_RECORD_COMPARISON
   
inherit
      
   SORT_CONSTANTS
   DATABASE_DEMO_CONSTANTS
   FORM_MANAGER_CLIENT
   DATABASE_RECORD_COMPARISON
      redefine
	 compare_records
      end
      
creation
   
   make
      
feature {ANY} --comparison features
   
   demo_record_a : DEMO_RECORD

   demo_record_b : DEMO_RECORD
   
   sort_first_by : INTEGER_16
   
   sort_second_by : INTEGER_16
   
   sort_third_by : INTEGER_16
   
   set_sort_criteria( new_first, new_second, new_third : INTEGER_16 ) is
      do
	 sort_first_by := new_first
	 sort_second_by := new_second
	 sort_third_by := new_third
      end
   
   make is
      do
	 create demo_record_a
	 create demo_record_b
	 sort_first_by := Sort_by_name
	 sort_second_by := Sort_by_quantity
      end
   
   compare_name : INTEGER_16 is
	 --three way comparison based on name
      do
	 Result := demo_record_a.name.three_way_comparison( demo_record_b.name ).to_integer_16
      end
   
   compare_quantity : INTEGER_16 is
      do
	 Result := demo_record_a.quantity.three_way_comparison( demo_record_b.quantity ).to_integer_16
      end
   
   compare_alpha : INTEGER_16 is
      do
	 Result := demo_record_a.alpha_code.three_way_comparison( demo_record_b.alpha_code ).to_integer_16
      end
   
   compare_criterion( sort_by : INTEGER_16 ) : INTEGER_16 is
      do
	 inspect sort_by
	 when Sort_by_alpha then
	    Result := compare_alpha
	 when Sort_by_name then
	    Result := compare_name
	 when Sort_by_quantity then
	    Result := compare_quantity
	 end
      end
   
   compare_records( record_a, record_b : POINTER;
						  other_info : INTEGER_16;
						  sort_info_a, sort_info_b, app_info_handle : POINTER ) : INTEGER_16 is
      do
	 demo_record_a.read_from_pointer( record_a )
	 demo_record_b.read_from_pointer( record_b )
	 
	 Result := compare_criterion( sort_first_by )
	 if Result = 0 then Result := compare_criterion( sort_second_by ) end
	 if Result = 0 then Result := compare_criterion( sort_third_by ) end
      end

end

	       
