
class SORT_FORM_EVENT_HANDLER

inherit
   FORM_MANAGER_CLIENT
   DATABASE_DEMO_CONSTANTS
   SORT_CONSTANTS
   STANDARD_EVENT_HANDLER
      redefine
	 handle_ctl_select_event
      end
   
feature {ANY} --marshaling values around
   
   sort_first_by : INTEGER_16
   sort_second_by : INTEGER_16
   sort_third_by : INTEGER_16
   
   first_control_group_id( sort_by : INTEGER_16 ) : INTEGER_16 is
      do
	 inspect sort_by
	 when Sort_by_alpha then
	    Result := Sort_first_alpha
	 when Sort_by_quantity then
	    Result := Sort_first_quantity
	 when Sort_by_name then
	    Result := Sort_first_name
	 end
      end
   
   second_control_group_id( sort_by : INTEGER_16 ) : INTEGER_16 is
      do
	 inspect sort_by
	 when Sort_by_alpha then
	    Result := Sort_second_alpha
	 when Sort_by_quantity then
	    Result := Sort_second_quantity
	 when Sort_by_name then
	    Result := Sort_second_name
	 end
      end
   
   third_control_group_id( sort_by : INTEGER_16 ) : INTEGER_16 is
      do
	 inspect sort_by
	 when Sort_by_alpha then
	    Result := Sort_third_alpha
	 when Sort_by_quantity then
	    Result := Sort_third_quantity
	 when Sort_by_name then
	    Result := Sort_third_name
	 end
      end
   
   sort_by_from_control_id( id : INTEGER_16 ) : INTEGER_16 is
      do
	 inspect id
	 when Sort_first_alpha, Sort_second_alpha, Sort_third_alpha then
	    Result := Sort_by_alpha
	 when Sort_first_quantity, Sort_second_quantity, Sort_third_quantity then
	    Result := Sort_by_quantity
	 when Sort_first_name, Sort_second_name, Sort_third_name then
	    Result := Sort_by_name
	 end
      end
   
feature {ANY} -- "preferred" choices for second or third tiers once previous tiers are selected
   
   second_tier_choice( first_tier : INTEGER_16 ) : INTEGER_16 is
      do
	 inspect first_tier
	 when Sort_by_alpha then Result := Sort_by_quantity
	 when Sort_by_quantity then Result := Sort_by_name
	 when Sort_by_name then Result := Sort_by_alpha
	 end
      end
   
   third_tier_choice( first_tier, second_tier : INTEGER_16 ) : INTEGER_16 is
      do
	 inspect first_tier
	 when Sort_by_alpha then
	    inspect second_tier
	    when Sort_by_quantity then Result := Sort_by_name
	    when Sort_by_name then Result := Sort_by_quantity
	    end
	 when Sort_by_quantity then
	    inspect second_tier
	    when Sort_by_alpha then Result := Sort_by_name
	    when Sort_by_name then Result := Sort_by_alpha
	    end
	 when Sort_by_name then
	    inspect second_tier
	    when Sort_by_alpha then Result := Sort_by_quantity
	    when Sort_by_quantity then Result := Sort_by_alpha
	    end
	 end
      end
   
   
feature {ANY} -- setters for categories	    
	 
   set_sort_first_by( sort_by : INTEGER_16 ) is
	 --record the first "sort by" category and change UI to reflect 
	 --this choice (graying out options in second and third categories)
      do
	 sort_first_by := sort_by
	 form_manager.active_form.set_control_group_selection_by_id( 2, first_control_group_id( sort_by ) )
	 inspect sort_by
	 when Sort_by_alpha then
	    show_control( second_control_group_id( Sort_by_name ) )
	    show_control( second_control_group_id( Sort_by_quantity ) )
	    show_control( third_control_group_id( Sort_by_name ) )
	    show_control( third_control_group_id( Sort_by_quantity ) )
	 when Sort_by_name then
	    show_control( second_control_group_id( Sort_by_alpha ) )
	    show_control( second_control_group_id( Sort_by_quantity ) )
	    show_control( third_control_group_id( Sort_by_alpha ) )
	    show_control( third_control_group_id( Sort_by_quantity ) )
	 when Sort_by_quantity then
	    show_control( second_control_group_id( Sort_by_alpha ) )
	    show_control( second_control_group_id( Sort_by_name ) )
	    show_control( third_control_group_id( Sort_by_alpha ) )
	    show_control( third_control_group_id( Sort_by_name ) )
	 end
	 set_sort_second_by( second_tier_choice( sort_by ) )
	 hide_control( second_control_group_id( sort_by ) )
	 hide_control( third_control_group_id( sort_by ) )
      end
   
   set_sort_second_by( sort_by : INTEGER_16 ) is
	 --record the second "sort by" category and change UI to reflect 
	 --this choice (graying out options in third category)
      do
	 sort_second_by := sort_by
	 form_manager.active_form.set_control_group_selection_by_id( 3, second_control_group_id( sort_by ) )
	 inspect sort_by
	 when Sort_by_alpha then
	    inspect sort_first_by
	    when Sort_by_name then show_control( third_control_group_id( Sort_by_quantity ) )
	    when Sort_by_quantity then show_control( third_control_group_id( Sort_by_name ) )
	    end
	 when Sort_by_name then
	    inspect sort_first_by
	    when Sort_by_alpha then show_control( third_control_group_id( Sort_by_quantity ) )
	    when Sort_by_quantity then show_control( third_control_group_id( Sort_by_alpha ) )	    
	    end
	 when Sort_by_quantity then
	    inspect sort_first_by
	    when Sort_by_alpha then show_control( third_control_group_id( Sort_by_name ) )	    
	    when Sort_by_name then show_control( third_control_group_id( Sort_by_alpha ) )	    
	    end
	 end
	 set_sort_third_by( third_tier_choice( sort_first_by, sort_second_by ) )
	 hide_control( third_control_group_id( sort_by ) )
      end
   
   set_sort_third_by( sort_by : INTEGER_16 ) is
	 --record the third "sort by" category and change UI to 
	 --reflect this choice
      do
	 sort_third_by := sort_by
	 form_manager.active_form.set_control_group_selection_by_id( 4, third_control_group_id( sort_by ) )
      end
   
   hide_control( control_id : INTEGER_16 ) is
      do
	 form_manager.active_form.hide_object( form_manager.active_form.object_index_from_id( control_id ) )
      end
   
   show_control( control_id : INTEGER_16 ) is
      do
	 form_manager.active_form.show_object( form_manager.active_form.object_index_from_id( control_id ) )
      end
   
   
feature {ANY} -- event handlers
   
   handle_ctl_select_event( event : EVENT ) is
      do
	 last_event_was_handled := True
	 inspect event.data_ctlselect_controlid
	 when Sort_first_alpha then
	    set_sort_first_by( Sort_by_alpha )
	 when Sort_first_quantity then
	    set_sort_first_by( Sort_by_quantity )
	 when Sort_first_name then
	    set_sort_first_by( Sort_by_name )
	 when Sort_second_alpha then
	    set_sort_second_by( Sort_by_alpha )
	 when Sort_second_quantity then
	    set_sort_second_by( Sort_by_quantity )
	 when Sort_second_name then
	    set_sort_second_by( Sort_by_name )
	 when Sort_third_alpha then
	    set_sort_third_by( Sort_by_alpha )
	 when Sort_third_quantity then
	    set_sort_third_by( Sort_by_quantity )
	 when Sort_third_name then
	    set_sort_third_by( Sort_by_name )
	 else
	    last_event_was_handled := False
	 end
      end
	 
   
end
	 
