#program to convert a text file 

class Basic_mqf_record

  attr_accessor :reference, :question, :answer_a, :answer_b, 
    :answer_c, :answer_d, :answer_key

  def initialize( str )
    @reference, @question, @answer_a, @answer_b, 
      @answer_c, @answer_d, @answer_key = str.split( "|" )
  end

  def packed_string( str ) 
    [str].pack( "a#{str.length + 1}") 
  end
    
  def packed_record
    packed_string( @reference ) +
      packed_string( @question ) +
      packed_string( @answer_a ) +
      packed_string( @answer_b ) +
      packed_string( @answer_c ) +
      packed_string( @answer_d ) +
      [@answer_key.to_i].pack( "n" )
  end
end
  
def records_from_strings( strs )
  result = []
  strs.each { |str| 
    if str.split( "|" ).length == 7
      r = Basic_mqf_record.new( str )
      result << r
    else
      print "Rejected: " + str
    end
  }
  result
end

def records_from_file( filename )
  strs = IO.readlines( filename )
  records_from_strings( strs )
end

require "pdbtools.rb"

a = Pdbtools::Pdb.new
a.attributes = Pdbtools::Pdb::Backup_this_database_attribute | Pdbtools::Pdb::Okay_to_install_newer_attribute
a.version = 1
a.create_time = a.time_from_rubytime( Time.new )
a.modify_time = a.time_from_rubytime( Time.new )
a.backup_time = 0
a.modification_number = 0
r = records_from_file( ARGV[0] )
i = 1
r.each { |record|
  a.add_record( record.packed_record, 0, [0,i].pack("Cn") )
  i = i + 1
}
#set PDB parameters
a.name = "test mqf quiz"
a.type = "emqf"
a.creator = "emqf"
a.write_to_file( ARGV[1] )
