

indexing
   contents: "generated wrapper for C type "
   author: "Victor B. Putz"
   completed: no
   tested: no
   

class DATABASE_MANAGER
inherit


   

   
feature {ANY} -- direct Eiffel features

   last_error : INTEGER_16


   create_database( card_number : INTEGER_16; name: STRING; creator, type : INTEGER_32; is_resource_database : BOOLEAN ) is
      do
         last_error := create_database_base( card_number, name.to_external, creator, type, is_resource_database )
      end


   create_database_from_image( p_image : POINTER ) is
      do
         last_error := create_database_from_image_base( p_image )
      end



   last_database_info_name_array : POINTER is external "C" end

   last_database_info_name : STRING

   last_database_info_attributes : INTEGER_16

   last_database_info_version : INTEGER_16

   last_database_info_creation_date : INTEGER_32

   last_database_info_modification_date : INTEGER_32

   last_database_info_backup_date : INTEGER_32

   last_database_info_modification_number : INTEGER_32

   last_database_info_app_info_id : LOCAL_ID

   last_database_info_sort_info_id : LOCAL_ID

   last_database_info_type : INTEGER_32

   last_database_info_creator : INTEGER_32

   get_database_info( card_number : INTEGER_16; local_id : LOCAL_ID ) is
         --gets various information about a database and stores it
         --in the last_database_info_* features
      do
         if last_database_info_name = Void then create last_database_info_name.make( 32 ) end
         last_error := get_database_info_base( card_number, local_id.value, 
            last_database_info_name_array, 
            $last_database_info_attributes, 
            $last_database_info_version, 
            $last_database_info_creation_date, 
            $last_database_info_modification_date,
            $last_database_info_backup_date,
            $last_database_info_modification_number,
            $last_database_info_app_info_id,
            $last_database_info_sort_info_id,
            $last_database_info_type,
            $last_database_info_creator )
         last_database_info_name.from_external_copy( last_database_info_name_array )
   end


   set_protection( card_number : INTEGER_16; db_id : LOCAL_ID; new_is_protected : BOOLEAN ) is
      do
         last_error := set_protection_base( card_number, db_id.value, new_is_protected )
      end


   delete_database( card_number : INTEGER_16; local_id : LOCAL_ID ) is
      do
         last_error := delete_database_base( card_number, local_id.value )
      end


   find_database( card_number : INTEGER_16; name : STRING ) : LOCAL_ID is 
      do
         Result.set_value( find_database_base( card_number, name.to_external ) )
      end


   database_id_from_card_number_and_index( card_number, index : INTEGER_16 ) : LOCAL_ID is
      do
         Result.set_value( database_id_from_card_number_and_index_base( card_number, index ) )
      end


   last_next_database_card_number : INTEGER_16
      --last card number found by get_next_database_by_type_and_creator

   last_next_database_local_id : LOCAL_ID
      --last local ID found by get_next_database_by_type_and_creator

   get_next_database_by_type_and_creator( is_new_search : BOOLEAN;
                                          search_state : DATABASE_MANAGER_SEARCH_STATE;
                                          type, creator : INTEGER_32;
                                          get_only_latest_version : BOOLEAN ) is
      do
         last_error := get_next_database_by_type_creator_base( is_new_search, search_state.opaque_pointer, type, creator, get_only_latest_version, $last_next_database_card_number, $last_next_database_local_id )
      end
   


   open_database( card_number : INTEGER_16; database_id : LOCAL_ID; mode : INTEGER_16 ) : DATABASE is
      do
        create Result.from_shared_memory( open_database_base( card_number, database_id.value, mode ) )
      end


   open_database_by_type_and_creator( type, creator : INTEGER_32; mode : INTEGER_16 ) : DATABASE is
      do
         create Result.from_shared_memory( open_database_by_type_and_creator_base( type, creator, mode ) )
      end


   resize_resource( h : MEM_HANDLE; new_size : INTEGER_32 ) : MEM_HANDLE is
      do
         create Result.from_handle( resize_resource_base( h.handle, new_size.value ) )
      end


   set_database_memory( p : POINTER; offset, num_bytes : INTEGER_32; value : CHARACTER ) is
      do
         last_error := set_database_memory_base( p, offset.value, num_bytes.value, value )
      end



   null_pointer : POINTER

   set_database_name( card_number : INTEGER_16; local_id : LOCAL_ID; name : STRING ) is
      do
	 last_error := set_database_info_base( card_number, local_id.value, name.to_external, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer )
      end
   
   temp : INTEGER_16
   
   set_database_attributes( card_number : INTEGER_16; local_id : LOCAL_ID; new_attributes : INTEGER_16 ) is
      do
	 temp := new_attributes
	 last_error := set_database_info_base( card_number, local_id.value, null_pointer, $temp, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer )
      end
   
   set_database_version( card_number : INTEGER_16; local_id : LOCAL_ID; new_version : INTEGER_16 ) is
      do
	 temp := new_version
	 last_error := set_database_info_base( card_number, local_id.value, null_pointer, null_pointer, $temp, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer )
      end
   
   set_database_creation_date( card_number : INTEGER_16; local_id : LOCAL_ID; new_creation_date : INTEGER_32 ) is
      do
	 last_error := set_database_info_base( card_number, local_id.value, null_pointer, null_pointer, null_pointer, $new_creation_date, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer )
      end
   
   set_database_modification_date( card_number : INTEGER_16; local_id : LOCAL_ID; new_modification_date : INTEGER_32 ) is
      do
	 last_error := set_database_info_base( card_number, local_id.value, null_pointer, null_pointer, null_pointer, null_pointer, $new_modification_date, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer )
      end
   
   set_database_backup_date( card_number : INTEGER_16; local_id : LOCAL_ID; new_backup_date : INTEGER_32 ) is
      do
	 last_error := set_database_info_base( card_number, local_id.value, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, $new_backup_date, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer )
      end
   
   set_database_modification_number( card_number : INTEGER_16; local_id : LOCAL_ID; new_modification_number : INTEGER_32 ) is
      do
	 last_error := set_database_info_base( card_number, local_id.value, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, $new_modification_number, null_pointer, null_pointer, null_pointer, null_pointer )
      end
   
   set_database_application_info( card_number : INTEGER_16; local_id : LOCAL_ID; new_app_info_id : LOCAL_ID ) is
      do
	 last_error := set_database_info_base( card_number, local_id.value, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, $new_app_info_id, null_pointer, null_pointer, null_pointer )
      end
   
   set_database_sort_info( card_number : INTEGER_16; local_id : LOCAL_ID; new_sort_info : LOCAL_ID ) is
      do
	 last_error := set_database_info_base( card_number, local_id.value, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, $new_sort_info, null_pointer, null_pointer )
      end
   
   set_database_type( card_number : INTEGER_16; local_id : LOCAL_ID; new_type : INTEGER_32 ) is
      do
	 last_error := set_database_info_base( card_number, local_id.value, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, $new_type, null_pointer )
      end
   
   set_database_creator( card_number : INTEGER_16; local_id : LOCAL_ID; new_creator : INTEGER_32 ) is
      do
	 last_error := set_database_info_base( card_number, local_id.value, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, null_pointer, $new_creator )
      end
   


   string_copy( p : POINTER; offset : INTEGER_32; source : STRING ) is
      do
         last_error := string_copy_base( p, offset.value, source.to_external )
      end


   write( p : POINTER; offset : INTEGER_32; p_source : POINTER; bytes_to_copy : INTEGER_32 ) is
      do
         last_error := write_base( p, offset.value, p_source, bytes_to_copy.value )
      end


   write_check( p : POINTER; offset, bytes_to_copy : INTEGER_32 ) is
      do
         last_error := write_check_base( p, offset.value, bytes_to_copy.value )
      end


current_comparison : DATABASE_RECORD_COMPARISON

set_current_comparison( new_comparison : DATABASE_RECORD_COMPARISON ) is
      require
	 new_comparison /= void
      do
	 current_comparison := new_comparison
      ensure
	 current_comparison = new_comparison
      end
   
   compare_database_records( a, b : POINTER; other : INTEGER_16; 
									  sort_info_a : POINTER;
									  sort_info_b, app_info_handle : POINTER ) : INTEGER_16 is
      require
	 current_comparison /= void
      do
	 Result := current_comparison.compare_records( a, b, other, sort_info_a, sort_info_b, app_info_handle )
      end


feature {ANY} -- structure features (aliased)

feature {ANY} -- aliased helper features for above

feature {ANY} -- aliased C features
   create_database_from_image_base (buffer : POINTER) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmCreateDatabaseFromImage"
      end

   get_database_info_base (card_number : INTEGER_16; local_id_int32 : INTEGER_32; p_name : POINTER; p_attributes : POINTER; p_version : POINTER; p_creation_date : POINTER; p_modification_date : POINTER; p_backup_date : POINTER; p_modification_number : POINTER; p_app_info_id : POINTER; p_sort_info_id : POINTER; p_type : POINTER; p_creator : POINTER) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmDatabaseInfo"
      end

   set_protection_base (card_number : INTEGER_16; db_id : POINTER; new_is_protected : BOOLEAN) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmDatabaseProtect"
      end

   delete_database_base (card_number : INTEGER_16; local_id : POINTER) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmDeleteDatabase"
      end

   find_database_base (card_number : INTEGER_16; p_name : POINTER) : INTEGER_32 is
      external "C use <DataMgr.h>"
      alias "DmFindDatabase"
      end

   database_id_from_card_number_and_index_base (card_number : INTEGER_16; index : INTEGER_16) : POINTER is
      external "C use <DataMgr.h>"
      alias "DmGetDatabase"
      end

   last_error_lookup  : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmGetLastErr"
      end

   number_of_databases_on_card (card_number : INTEGER_16) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmNumDatabases"
      end

   set_database_info_base (card_number : INTEGER_16; uint32_localid : POINTER; p_char_name : POINTER; p_uint16_attributes : POINTER; p_uint16_version : POINTER; p_uint32_creation_date : POINTER; p_uint32_modification_date : POINTER; p_uint32_backup_date : POINTER; p_uint32_modification_number : POINTER; p_uint32_app_info : POINTER; p_uint32_sort_info : POINTER; p_uint32_type : POINTER; p_uint32_creator : POINTER) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmSetDatabaseInfo"
      end


feature {ANY} -- data features

feature {ANY} -- c_with_pointer features

feature {ANY} -- c_without_pointer features
   create_database_base (card_number : INTEGER_16; p_name : POINTER; creator : INTEGER_32; type : INTEGER_32; is_resource_database : BOOLEAN) : INTEGER_16 is
      do
         Result := c_database_manager_create_database_base( card_number, p_name, creator, type, is_resource_database )
      end

   get_next_database_by_type_creator_base (is_new_search : BOOLEAN; search_state_pointer : POINTER; type, creator : INTEGER_32; get_only_latest_version : BOOLEAN; p_card_number : POINTER; p_local_id : POINTER) : INTEGER_16 is
      do
         Result := c_database_manager_get_next_database_by_type_creator_base( is_new_search, search_state_pointer, type, creator, get_only_latest_version, p_card_number, p_local_id )
      end

   open_database_base (card_number : INTEGER_16; database_id : INTEGER_32; mode : INTEGER_16) : POINTER is
      do
         Result := c_database_manager_open_database_base( card_number, database_id, mode )
      end

   open_database_by_type_and_creator_base ( type, creator : INTEGER_32; 
					    mode : INTEGER_16) : POINTER is
      do
         Result := c_database_manager_open_database_by_type_and_creator_base( type, creator, mode )
      end

   resize_resource_base (resource_handle : POINTER; new_size : INTEGER_32 ) : POINTER is
      do
         Result := c_database_manager_resize_resource_base( resource_handle, uint32_new_size )
      end

   set_database_memory_base (p : POINTER; uint32_offset : POINTER; uint32_num_bytes : POINTER; value : CHARACTER) : INTEGER_16 is
      do
         Result := c_database_manager_set_database_memory_base( p, uint32_offset, uint32_num_bytes, value )
      end

   string_copy_base (p : POINTER; uint32_offset : POINTER; p_source : POINTER) : INTEGER_16 is
      do
         Result := c_database_manager_string_copy_base( p, uint32_offset, p_source )
      end

   write_base (p : POINTER; uint32_offset : POINTER; p_source : POINTER; uint32_bytes_to_copy : POINTER) : INTEGER_16 is
      do
         Result := c_database_manager_write_base( p, uint32_offset, p_source, uint32_bytes_to_copy )
      end

   write_check_base (p : POINTER; uint32_offset : POINTER; uint32_bytes_to_copy : POINTER) : INTEGER_16 is
      do
         Result := c_database_manager_write_check_base( p, uint32_offset, uint32_bytes_to_copy )
      end


feature {NONE} -- data feature support functions

feature {NONE} -- c_with_pointer feature support functions

feature {NONE} -- c_without_pointer feature support functions
   c_database_manager_create_database_base ( card_number : INTEGER_16; 
					     p_name : POINTER; 
					     uint32_creator : INTEGER_32; 
					     uint32_type : INTEGER_32; 
					     is_resource_database : BOOLEAN )  : INTEGER_16 is 
      external "C use <DataMgr.h>" 
      alias "DmCreateDatabase"
      end

   c_database_manager_get_next_database_by_type_creator_base ( is_new_search : BOOLEAN; 
							       search_state_pointer : POINTER; 
							       type, creator : INTEGER_32;
							       get_only_latest_version : BOOLEAN; 
							       p_card_number : POINTER; 
							       p_local_id : POINTER )  : INTEGER_16 is 
      external "C use <DataMgr.h>" 
      alias "DmGetNextDatabaseByTypeCreator"
      end

   c_database_manager_open_database_base ( card_number : INTEGER_16; 
					   database_id : INTEGER_32; 
					   mode : INTEGER_16 )  : POINTER is 
      external "C use <DataMgr.h>" 
      alias "DmOpenDatabase"
      end

   c_database_manager_open_database_by_type_and_creator_base ( type, creator : INTEGER_32; 
							       mode : INTEGER_16 )  : POINTER is 
      external "C use <DataMgr.h>" 
      alias "DmOpenDatabaseByTypeCreator"
      end

   c_database_manager_resize_resource_base ( resource_handle : POINTER; 
					     new_size : INTEGER_32 )  : POINTER is 
      external "C use <DataMgr.h>" 
      alias "DmResizeResource"
      end

   c_database_manager_set_database_memory_base ( p : POINTER; 
						 offset, bytes : INTEGER_32;
						 value : CHARACTER ) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmSet"
      end
   
   c_database_manager_string_copy_base ( p : POINTER; 
					 offset : INTEGER_32; 
					 p_source : POINTER )  : INTEGER_16 is 
      external "C use <DataMgr.h>" 
      alias "DmStrCopy"
      end

   c_database_manager_write_base ( p : POINTER; 
				   offset : INTEGER_32; 
				   p_source : POINTER; 
				   bytes : INTEGER_32 )  : INTEGER_16 is 
      external "C use <DataMgr.h>" 
      alias "DmWrite"
      end

   c_database_manager_write_check_base ( p : POINTER; 
					 offset, bytes : INTEGER_32 ) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmWriteCheck"
      end

end
