indexing
   contents: "Form dispatcher object--takes over FrmDispatchEvent duties"
   author : "Victor B. Putz"
   completed : no
   tested : no
   
class FORM_DISPATCHER
   --takes over the FrmDispatchEvent duties; 
   --the FORM_DISPATCHER.dispatch_event_from_pointer is exported via
   --cecil and calls the appropriate handler
   
inherit
   FORM_MANAGER_CLIENT

creation 
   make
   
feature {NONE}
   
   dispatch_map : DICTIONARY[ EVENT_HANDLER, POINTER ]
   
feature {ANY}   
   
   set_event_handler( event_handler : EVENT_HANDLER; form : FORM ) is
      do
	 dispatch_map.put( event_handler, form.opaque_pointer );
	 form_dispatcher_set_event_handler( form.opaque_pointer )
      end
   
   dispatch_event_from_pointer( pointer : POINTER ) : BOOLEAN is
      local
	 event : EVENT
      do
	 create event.from_shared_memory( pointer )
	 Result := dispatch_event( event )
      end
   
   dispatch_event( event : EVENT ) : BOOLEAN is
	 --dispatch the event to the currently selected form
      local
	 form : FORM
      do
	 form := form_manager.active_form
	 Result := False
	 if dispatch_map.has( form.opaque_pointer ) then
	    dispatch_map.at( form.opaque_pointer ).handle_event( event )
	    Result := dispatch_map.at( form.opaque_pointer ).last_event_was_handled
	 end
      end
   
   dispatch_event_to_os( event : EVENT ) is
      do
	 form_dispatcher_dispatch_event_to_os( event.opaque_pointer )
      end
   
   make is
      do
	 create dispatch_map.with_capacity(5)
      end
   
feature {NONE} -- C implementations   
   
   form_dispatcher_set_event_handler( form : POINTER ) is
      external "C inline"
      alias "FrmSetEventHandler( $form, form_dispatcher_event_handler )"
	 --form_dispatcher_event_handler is in the epalm runtime 
	 --base.c file
      end
   
   form_dispatcher_dispatch_event_to_os( pointer : POINTER ) is
      external "C use <Form.h>"
      alias "FrmDispatchEvent"
      end
   
end

	 
