indexing
   contents : "The form manager duties--shared with the form class"
   author : "Victor B. Putz"
   completed : no
   tested : no
   
class FORM_MANAGER
   
feature {ANY}
   
   go_to_form( form_id : INTEGER_16 ) is
	 --wraps the FrmGotoForm function
      external "C use <Form.h>"
      alias "FrmGotoForm"
      end
   
   popup_form( form_id : INTEGER_16 ) is
	 --wraps the FrmPopupForm function
      external "C use <Form.h>"
      alias "FrmPopupForm"
      end
   
   return_to_form( form_id : INTEGER_16 ) is
	 --wraps the FrmReturnToForm function
      external "C use <Form.h>"
      alias "FrmReturnToForm"
      end
   
   close_all_forms is
	 --wraps FrmCloseAllForms
      external "C use <Form.h>"
      alias "FrmCloseAllForms"
      end
   
   update_form( form_id, update_code : INTEGER_16 ) is 
	 --sends an update event to the given form; see FrmUpdateForm
      external "C use <Form.h>"
      alias "FrmUpdateForm"
      end
   
   active_form : FORM is
      do
	 create Result.from_shared_memory( c_form_manager_get_active_form )
      end
   
   active_form_id : INTEGER_16 is
	 --wrapper for FrmGetActiveFormID
      external "C use <Form.h>"
      alias "FrmGetActiveFormID"
      end
	 
   first_form : FORM is
      do
	 create Result.from_shared_memory( c_form_manager_get_first_form )
      end
      
   
   alert( form_id : INTEGER_16 ) is
      do
	 last_alert_button_selected := c_form_manager_alert( form_id )
      end
   
   custom_alert( form_id : INTEGER_16; msg1, msg2, msg3 : STRING ) is
      require
	 msg1 /= Void
	 msg2 /= Void
	 msg3 /= Void
      do
	 last_alert_button_selected := c_form_manager_custom_alert( form_id, msg1.to_external, 
								    msg2.to_external, msg3.to_external )
      end
   
   last_alert_button_selected : INTEGER_16
	 --the button the user selected to clear an alert box
   
   help_dialog( message_id : INTEGER_16 ) is
	 --displays a dialog with the given help string (FrmHelp)
      external "C"
      alias "FrmHelp"
      end
   
feature {NONE} -- c wrappers
   
   c_form_manager_get_active_form : POINTER is
      external "C use <Form.h>"
      alias "FrmGetActiveForm"
      end
   
   c_form_manager_get_first_form : POINTER is
      external "C use <Form.h>"
      alias "FrmGetFirstForm"
      end
   
   c_form_manager_alert( form_id : INTEGER_16 ) : INTEGER_16 is
      external "C use <Form.h>"
      alias "FrmAlert"
      end
   
   c_form_manager_custom_alert( form_id : INTEGER_16; msg1, msg2, msg3 : POINTER ) : INTEGER_16 is
      external "C use <Form.h>"
      alias "FrmCustomAlert"
      end
   
end

   
   
	 
