indexing
   contents : "Basic shell of eiffel PalmOS application"
   author : "Victor B. Putz"
   completed : no
   tested : no

class PALM_APPLICATION

inherit
   EVENT_CONSTANTS
   LAUNCH_CODE_CONSTANTS
   FORM_MANAGER_CLIENT
   FORM_DISPATCHER_CLIENT
   EVENT_HANDLER
      redefine
	 handle_event
      end

creation
   pilot_main

feature {ANY}

   last_event : EVENT
   
   start_application is
      -- Do any actions necessary at application startup.  This is 
      -- called by default from pilot_main
      do
      end

   stop_application is
      -- any actions necessary at application shutdown; called by 
      -- pilot_main
      do
      end
   
   event_timeout : INTEGER_16 is 
      do
	 Result := Evt_wait_forever
      end
	 --redefine to change event loop behaviour
   
   event_loop is
      -- the main application event loop; by default, gets a new 
      -- event, passes it to system and menu application handlers, 
      -- then passes it to the application's handle_event member
      local
	 loop_finished : BOOLEAN
      do
	 from
	    loop_finished := False
	 until
	    loop_finished = True
	 loop
	    last_event.get( event_timeout )
	    system_event_handler.handle_event( last_event )
	    if system_event_handler.last_event_was_handled = False then
	       menu_event_handler.handle_event( last_event )
	       if menu_event_handler.last_event_was_handled = False then
		  handle_event( last_event )
		  if last_event_was_handled = False then
		     form_dispatcher.dispatch_event_to_os( last_event )
		  end
	       end
	    end
	    if last_event.type = App_stop_event then
	       loop_finished := True
	    end
	 end
      end

   pilot_main is
      do
	 create last_event.as_new_memory
	 create system_event_handler
	 create menu_event_handler
	 if launch_code = Sys_app_launch_cmd_normal_launch then
	    start_application
	    event_loop
	    stop_application
	    form_manager.close_all_forms
	 end
      end

feature {ANY} -- event handlers

   menu_event_handler : MENU_EVENT_HANDLER

   system_event_handler : SYSTEM_EVENT_HANDLER
   
   handle_event( event : EVENT ) is
      do
	 last_event_was_handled := False
      end
   
feature {ANY} -- startup parameters   
   
   launch_code : INTEGER_16
   
   cmd_pbp : POINTER
   
   launch_flags : INTEGER_16
   
end
