indexing
   contents : "basic event handler for PalmOS events"
   author : "Victor B. Putz"
   completed : no
   tested : no

class STANDARD_EVENT_HANDLER
   
inherit   
   EVENT_CONSTANTS
   EVENT_HANDLER
      redefine
	 handle_event
      end
   
feature {ANY}

   handle_event( event : EVENT ) is 
      -- handles events by dispatching them (based on type) to 
      -- various helper functions which can be redefined in child classes
      do
	 last_event_was_handled := False
	 inspect event.type
	 when Nil_event then
	    handle_nil_event( event )
	 when Pen_down_event then
	    handle_pen_down_event( event )
	 when Pen_up_event then
	    handle_pen_up_event( event )
	 when Key_down_event then
	    handle_key_down_event( event )
	 when Win_enter_event then
	    handle_win_enter_event( event )
	 when Win_exit_event then
	    handle_win_exit_event( event )
	 when Ctl_enter_event then
	    handle_ctl_enter_event( event )
	 when Ctl_exit_event then
	    handle_ctl_exit_event( event )
	 when Ctl_select_event then
	    handle_ctl_select_event( event )
	 when Ctl_repeat_event then
	    handle_ctl_repeat_event( event )
	 when Lst_enter_event then
	    handle_lst_enter_event( event )
	 when Lst_select_event then
	    handle_lst_select_event( event )
	 when Pop_select_event then
	    handle_pop_select_event( event )
	 when Fld_enter_event then
	    handle_fld_enter_event( event )
	 when Fld_height_changed_event then
	    handle_fld_height_changed_event( event )
	 when Fld_changed_event then
	    handle_fld_changed_event( event )
	 when Tbl_enter_event then
	    handle_tbl_enter_event( event )
	 when Tbl_select_event then
	    handle_tbl_select_event( event )
	 when Day_select_event then
	    handle_day_select_event( event )
	 when Menu_event then
	    handle_menu_event( event )
	 when App_stop_event then
	    handle_app_stop_event( event )
	 when Frm_load_event then
	    handle_frm_load_event( event )
	 when Frm_open_event then
	    handle_frm_open_event( event )
	 when Frm_goto_event then
	    handle_frm_goto_event( event )
	 when Frm_update_event then
	    handle_frm_update_event( event )
	 when Frm_save_event then
	    handle_frm_save_event( event )
	 when Frm_close_event then
	    handle_frm_close_event( event )
	 when Frm_title_enter_event then
	    handle_frm_title_enter_event( event )
	 when Frm_title_select_event then
	    handle_frm_title_select_event( event )
	 when Tbl_exit_event then
	    handle_tbl_exit_event( event )
	 when Scl_enter_event then
	    handle_scl_enter_event( event )
	 when Scl_exit_event then
	    handle_scl_exit_event( event )
	 when Scl_repeat_event then
	    handle_scl_repeat_event( event )
	 when Tsm_confirm_event then
	    handle_tsm_confirm_event( event )
	 when Tsm_fep_button_event then
	    handle_tsm_fep_button_event( event )
	 else
	    handle_other_event( event )
	 end
      end
   
feature { ANY } -- individual event handling functions   
   
   handle_nil_event( event : EVENT ) is do end
   handle_pen_down_event( event : EVENT ) is do end
   handle_pen_up_event( event : EVENT ) is do end
   handle_key_down_event( event : EVENT ) is do end
   handle_win_enter_event( event : EVENT ) is do end
   handle_win_exit_event( event : EVENT ) is do end
   handle_ctl_enter_event( event : EVENT ) is do end
   handle_ctl_exit_event( event : EVENT ) is do end
   handle_ctl_select_event( event : EVENT ) is do end
   handle_ctl_repeat_event( event : EVENT ) is do end
   handle_lst_enter_event( event : EVENT ) is do end
   handle_lst_select_event( event : EVENT ) is do end
   handle_lst_exit_event( event : EVENT ) is do end
   handle_pop_select_event( event : EVENT ) is do end
   handle_fld_enter_event( event : EVENT ) is do end
   handle_fld_height_changed_event( event : EVENT ) is do end
   handle_fld_changed_event( event : EVENT ) is do end
   handle_tbl_enter_event( event : EVENT ) is do end 
   handle_tbl_select_event( event : EVENT ) is do end
   handle_day_select_event( event : EVENT ) is do end
   handle_menu_event( event : EVENT ) is do end
   handle_app_stop_event( event : EVENT ) is do end
   handle_frm_load_event( event : EVENT ) is do end
   handle_frm_open_event( event : EVENT ) is do end
   handle_frm_goto_event( event : EVENT ) is do end
   handle_frm_update_event( event : EVENT ) is do end
   handle_frm_save_event( event : EVENT ) is do end
   handle_frm_close_event( event : EVENT ) is do end
   handle_frm_title_enter_event( event : EVENT ) is do end
   handle_frm_title_select_event( event : EVENT ) is do end
   handle_tbl_exit_event( event : EVENT ) is do end
   handle_scl_enter_event( event : EVENT ) is do end
   handle_scl_exit_event( event : EVENT ) is do end
   handle_scl_repeat_event( event : EVENT ) is do end
   handle_tsm_confirm_event( event : EVENT ) is do end
   handle_tsm_fep_button_event( event : EVENT ) is do end
   handle_other_event( event : EVENT ) is do end
   
end
