

indexing
   contents: "generated wrapper for C type "
   author: "Victor B. Putz"
   completed: no
   tested: no
   

class WINDOW_MANAGER
   
feature {ANY} -- direct Eiffel features

   draw_string( s : STRING; x, y : INTEGER_16 ) is
      do
         draw_characters( s.to_external, s.count, x, y )
      end


   draw_inverted_string( s : STRING; x, y : INTEGER_16 ) is
      do
         draw_inverted_characters( s.to_external, s.count, x, y )
      end


   draw_truncated_string( s : STRING; x, y, max_width : INTEGER_16 ) is
      do
         draw_truncated_characters( s.to_external, s.count, x, y, max_width )
      end


   erase_string( s : STRING; x, y : INTEGER_16 ) is
      do
         erase_characters( s.to_external, s.count, x, y )
      end


   invert_string( s : STRING; x, y : INTEGER_16 ) is
      do
         invert_characters( s.to_external, s.count, x, y )
      end


   previous_background_color : INTEGER_16

   set_background_color( new_color : INTEGER_16 ) is
      do
         previous_background_color := set_background_color_base( new_color )
      end


   previous_drawing_mode : INTEGER_16

   set_drawing_mode( new_drawing_mode : INTEGER_16 ) is
      do
         previous_drawing_mode := set_drawing_mode_base( new_drawing_mode )
      end


   previous_foreground_color : INTEGER_16 
 
   set_foreground_color( new_color : INTEGER_16 ) is
      do
         previous_foreground_color := set_foreground_color_base( new_color )
      end


   previous_text_color : INTEGER_16

   set_text_color( new_color : INTEGER_16 ) is 
      do
         previous_text_color := set_text_color_base( new_color )
      end


   previous_underline_mode : INTEGER_16

   set_underline_mode( new_mode : INTEGER_16 ) is
      do
         previous_underline_mode := set_underline_mode_base( new_mode ) 
      end


feature {ANY} -- c_without_pointer features
   draw_character (c : CHARACTER; x : INTEGER_16; y : INTEGER_16 )  is
      do
         c_window_manager_draw_character( c, x, y )
      end

   draw_characters (p_chars : POINTER; 
		    length, x, y : INTEGER_16 )  is
      do
         c_window_manager_draw_characters( p_chars, length, x, y )
      end

   draw_grey_line (x1, y1, x2, y2 : INTEGER_16 )  is
      do
         c_window_manager_draw_grey_line( x1, y1, x2, y2 )
      end

   draw_inverted_characters (p_chars : POINTER; 
			     length, x, y : INTEGER_16 )  is
      do
         c_window_manager_draw_inverted_characters( p_chars, length, x, y )
      end

   draw_line (x1, y1, x2, y2 : INTEGER_16 )  is
      do
         c_window_manager_draw_line( x1, y1, x2, y2 )
      end

   draw_pixel (x : INTEGER_16; y : INTEGER_16 )  is
      do
         c_window_manager_draw_pixel( x, y )
      end

   draw_truncated_characters (p_chars : POINTER; 
			      length, x, y, max_width : INTEGER_16 )  is
      do
         c_window_manager_draw_truncated_characters( p_chars, length, x, y, max_width )
      end

   erase_characters (p_chars : POINTER; 
		     length, x, y : INTEGER_16 )  is
      do
         c_window_manager_erase_characters( p_chars, length, x, y )
      end

   erase_line (x1, y1, x2, y2 : INTEGER_16 )  is
      do
         c_window_manager_erase_line( x1, y1, x2, y2 )
      end

   erase_pixel (x, y : INTEGER_16 )  is
      do
         c_window_manager_erase_pixel( x, y )
      end

   erase_window   is
      do
         c_window_manager_erase_window
      end

   fill_line (x1, y1, x2, y2 : INTEGER_16 )  is
      do
         c_window_manager_fill_line( x1, y1, x2, y2 )
      end

   get_pixel (x, y : INTEGER_16 ) : INTEGER_16 is
      do
         Result := c_window_manager_get_pixel( x, y )
      end

   invert_characters (p_chars : POINTER; 
		      length, x, y : INTEGER_16 )  is
      do
         c_window_manager_invert_characters( p_chars, length, x, y )
      end

   invert_line (x1, y1, x2, y2 : INTEGER_16 )  is
      do
         c_window_manager_invert_line( x1, y1, x2, y2 )
      end

   invert_pixel (x, y : INTEGER_16 )  is
      do
         c_window_manager_invert_pixel( x, y )
      end

   paint_character (c : CHARACTER; 
		    x, y : INTEGER_16 )  is
      do
         c_window_manager_paint_character( c, x, y )
      end

   paint_characters (p_chars : POINTER; 
		     length, x, y : INTEGER_16 )  is
      do
         c_window_manager_paint_characters( p_chars, length, x, y )
      end

   paint_line (x1, y1, x2, y2 : INTEGER_16 )  is
      do
         c_window_manager_paint_line( x1, y1, x2, y2 )
      end

   paint_pixel (x, y : INTEGER_16 )  is
      do
         c_window_manager_paint_pixel( x, y )
      end

   pop_draw_state   is
      do
         c_window_manager_pop_draw_state
      end

   push_draw_state   is
      do
         c_window_manager_push_draw_state
      end

   reset_clipping_rectangle   is
      do
         c_window_manager_reset_clipping_rectangle
      end

   set_background_color_base (new_color : INTEGER_16 ) : INTEGER_16 is
      do
         Result := c_window_manager_set_background_color_base( new_color )
      end

   set_drawing_mode_base (new_mode : INTEGER_16 ) : INTEGER_16 is
      do
         Result := c_window_manager_set_drawing_mode_base( new_mode )
      end

   set_foreground_color_base (new_color : INTEGER_16 ) : INTEGER_16 is
      do
         Result := c_window_manager_set_foreground_color_base( new_color )
      end

   set_pattern_type (new_type : INTEGER_16 )  is
      do
         c_window_manager_set_pattern_type( new_type )
      end

   set_text_color_base (new_color : INTEGER_16 ) : INTEGER_16 is
      do
         Result := c_window_manager_set_text_color_base( new_color )
      end

   set_underline_mode_base (new_mode : INTEGER_16 ) : INTEGER_16 is
      do
         Result := c_window_manager_set_underline_mode_base( new_mode )
      end


feature {NONE} -- c_without_pointer feature support functions
   c_window_manager_draw_character ( c : CHARACTER; 
				     x, y : INTEGER_16 ) is 
      external "C use <Window.h>" 
      alias "WinDrawChar"
      end

   c_window_manager_draw_characters ( p_chars : POINTER; 
				      length, x, y : INTEGER_16 )  is
      external "C use <Window.h>" 
      alias "WinDrawChars"
      end

   c_window_manager_draw_grey_line ( x1, y1, x2, y2 : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinDrawGrayLine"
      end

   c_window_manager_draw_inverted_characters ( p_chars : POINTER; 
					       length, x, y : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinDrawInvertedChars"
      end

   c_window_manager_draw_line ( x1, y1, x2, y2 : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinDrawLine"
      end

   c_window_manager_draw_pixel ( x, y : INTEGER_16 ) is 
      external "C use <Window.h>" 
      alias "WinDrawPixel"
      end

   c_window_manager_draw_truncated_characters ( p_chars : POINTER; 
						length, x, y, max_width : INTEGER_16 ) is 
      external "C use <Window.h>" 
      alias "WinDrawTruncChars"
      end

   c_window_manager_erase_characters ( p_chars : POINTER; 
				       length, x, y : INTEGER_16 ) is 
      external "C use <Window.h>" 
      alias "WinEraseChars"
      end

   c_window_manager_erase_line ( x1, y1, x2, y2 : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinEraseLine"
      end

   c_window_manager_erase_pixel ( x, y : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinErasePixel"
      end

   c_window_manager_erase_window   is 
      external "C use <Window.h>" 
      alias "WinEraseWindow"
      end

   c_window_manager_fill_line ( x1, y1, x2, y2 : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinFillLine"
      end

   c_window_manager_get_pixel ( x, y : INTEGER_16 ) is 
      external "C use <Window.h>" 
      alias "WinGetPixel"
      end

   c_window_manager_invert_characters ( p_chars : POINTER; 
					length, x, y : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinInvertChars"
      end

   c_window_manager_invert_line ( x1, y1, x2, y2  : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinInvertLine"
      end

   c_window_manager_invert_pixel ( x, y : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinInvertPixel"
      end

   c_window_manager_paint_character ( c : CHARACTER; 
				      x, y : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinPaintChar"
      end

   c_window_manager_paint_characters ( p_chars : POINTER; 
				       length, x, y : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinPaintChars"
      end

   c_window_manager_paint_line ( x1, y1, x2, y2 : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinPaintLine"
      end

   c_window_manager_paint_pixel ( x, y : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinPaintPixel"
      end

   c_window_manager_pop_draw_state   is 
      external "C use <Window.h>" 
      alias "WinPopDrawState"
      end

   c_window_manager_push_draw_state   is 
      external "C use <Window.h>" 
      alias "WinPushDrawState"
      end

   c_window_manager_reset_clipping_rectangle   is 
      external "C use <Window.h>" 
      alias "WinResetClip"
      end

   c_window_manager_set_background_color_base ( new_color : INTEGER_16 ) : INTEGER_16 is 
      external "C use <Window.h>" 
      alias "WinSetBackColor" 
      end

   c_window_manager_set_drawing_mode_base ( new_mode : INTEGER_16 )  : INTEGER_16 is 
      external "C use <Window.h>" 
      alias "WinSetDrawMode"
      end

   c_window_manager_set_foreground_color_base ( new_color : INTEGER_16 )  : INTEGER_16 is 
      external "C use <Window.h>" 
      alias "WinSetForeColor"
      end

   c_window_manager_set_pattern_type ( new_type : INTEGER_16 )  is 
      external "C use <Window.h>" 
      alias "WinSetPatternType"
      end

   c_window_manager_set_text_color_base ( new_color : INTEGER_16 )  : INTEGER_16 is 
      external "C use <Window.h>" 
      alias "WinSetTextColor"
      end

   c_window_manager_set_underline_mode_base ( new_mode : INTEGER_16 )  : INTEGER_16 is 
      external "C use <Window.h>" 
      alias "WinSetUnderlineMode"
      end


end
