

indexing
   contents: "generated wrapper for C type void"
   author: "Victor B. Putz"
   completed: no
   tested: no
   

class DATABASE
inherit
   C_STRUCT
      redefine
	 structure_size
      end

  DATABASE_MANAGER_CLIENT

   
creation
   from_shared_memory, from_orphaned_memory, as_new_memory
   
feature {ANY} -- direct Eiffel features

   structure_size : INTEGER_32 is
      do
         Result := 0
      end


   last_error : INTEGER_16


   archive_record( index : INTEGER_16 ) is
      do
         last_error := archive_record_base( index )
      end


   close is
      do
         last_error := close_base
      end


   delete_category( category_number : INTEGER_16 ) is
      do
         last_error := delete_category_base( category_number )
      end


   delete_record( index : INTEGER_16 ) is
      do
         last_error := delete_record_base( index )
      end

   
   last_record_index : INTEGER_16
   
   record_index_from_id( record_id : INTEGER_32 ) : INTEGER_16 is
      do
         last_error := c_dm_find_record_by_id( opaque_pointer, record_id, $last_record_index );
	 Result := last_record_index;
      end


   find_sort_position( p_new_record, new_record_info : POINTER;
                       comparison : DATABASE_RECORD_COMPARISON;
                       other_info : INTEGER_16 ) : INTEGER is
      --should return unsigned int16, but no data primitive is available
      do
	 database_manager.set_current_comparison( comparison )
	 Result := c_database_find_sort_position( opaque_pointer, p_new_record, 
						  new_record_info, other_info )
      end --find_sort_position
   
   c_database_find_sort_position( p, p_new_record, new_record_info : POINTER;
				  other : INTEGER_16 ) : INTEGER_16 is
      external "C"
      end
   


   application_info_id : LOCAL_ID is
      do
         Result.set_value( application_info_id_base )
      end


   record_from_index( index : INTEGER_16 ) : MEM_HANDLE is
      do
         create Result.from_handle( record_from_index_base( index ) )
      end


   resource_from_index( index : INTEGER_16 ) : MEM_HANDLE is
      do
         create Result.from_handle( resource_from_index_base( index ) )
      end


insertion_sort( comparison : DATABASE_RECORD_COMPARISON; other : INTEGER_16 ) is
      do
	 database_manager.set_current_comparison( comparison )
	 last_error := c_database_insertion_sort( opaque_pointer, other )
      end
   
   c_database_insertion_sort( p : POINTER; other : INTEGER_16 ) : INTEGER_16 is
      external "C"
      end


   move_category( to_category, from_category : INTEGER_16; set_is_dirty : BOOLEAN ) is
      do
         last_error := move_category_base( to_category, from_category, set_is_dirty )
      end


   move_record( from_index, to_index : INTEGER_16 ) is
      do
         last_error := move_record_base( from_index, to_index )
      end


   new_handle( new_handle_size : INTEGER_32 ) : MEM_HANDLE is
      do
         create Result.from_handle( c_dm_new_handle( opaque_pointer, new_handle_size ) )
      end


   last_new_record_index : INTEGER_16

   scratch_integer: INTEGER_16
   
   new_record( new_record_index : INTEGER_16; 
	       new_record_size : INTEGER_32 ) : MEM_HANDLE is
      do
	 
         create Result.from_handle( c_dm_new_record( opaque_pointer, $scratch_integer, new_record_size ) )
			last_new_record_index := scratch_integer
      end


   info_local_id : LOCAL_ID
   info_open_count : INTEGER_16
   info_mode : INTEGER_16
   info_card_number : INTEGER_16
   info_is_resource_database : BOOLEAN

   get_info is
      do
         last_error := get_info_base( info_local_id.p_value, $info_open_count, $info_mode, $info_card_number, $info_is_resource_database )
      end


   is_valid_index( index : INTEGER_16 ) : BOOLEAN is
      do
         Result := ( index >= 0 ) and ( index < number_of_records )
      end


   query_record( index : INTEGER_16 ) : MEM_HANDLE is
      do
         create Result.from_handle( query_record_base( index ) )
      end


quicksort( comparison : DATABASE_RECORD_COMPARISON; other : INTEGER_16 ) is
      do
	 database_manager.set_current_comparison( comparison )
	 last_error := c_database_quicksort( opaque_pointer, other )
      end
   
   c_database_quicksort( p : POINTER; other : INTEGER_16 ) : INTEGER_16 is
      external "C"
      end


   last_record_info_attributes : INTEGER_16
   last_record_info_id : INTEGER_32
   last_record_info_chunk : LOCAL_ID

   get_record_info( index : INTEGER_16 ) is
      -- gets information about the record at the given index and stores
      -- that information in last_record_info_attributes, last_record_info_id,
      -- and last_record_info_chunk.  Any error will be available in
      -- last_error
      do
         last_error := record_info_base( index, $last_record_info_attributes, last_record_info_id.p_value, last_record_info_chunk.p_value )
      end


   release_record_at_index( index : INTEGER_16; set_is_dirty : BOOLEAN ) is
      do
         last_error := release_record_at_index_base( index, set_is_dirty )
      end


   remove_record_at_index( index : INTEGER_16 ) is
      do
         last_error := remove_record_at_index_base( index )
      end


   remove_resource_at_index( index : INTEGER_16 ) is
      do
         last_error := remove_resource_at_index_base( index )
      end


   remove_secret_records is
      do
         last_error := remove_secret_records_base
      end


   resize_record( index : INTEGER_16; new_size : INTEGER_32 ) : MEM_HANDLE is
      do
         create Result.from_handle( c_dm_resize_record( opaque_pointer, index.to_integer_16, new_size ) )
      end


feature {ANY} -- structure features (aliased)
   archive_record_base (index : INTEGER_16) : INTEGER_16 is
      do
         Result := c_alias_archive_record_base( opaque_pointer, index )
      end


   close_base  : INTEGER_16 is
      do
         Result := c_alias_close_base( opaque_pointer )
      end


   delete_category_base (category_number : INTEGER_16) : INTEGER_16 is
      do
         Result := c_alias_delete_category_base( opaque_pointer, category_number )
      end


   delete_record_base (index : INTEGER_16) : INTEGER_16 is
      do
         Result := c_alias_delete_record_base( opaque_pointer, index )
      end


   application_info_id_base  : POINTER is
      do
         Result := c_alias_application_info_id_base( opaque_pointer )
      end


   record_from_index_base (index : INTEGER_16) : POINTER is
      do
         Result := c_alias_record_from_index_base( opaque_pointer, index )
      end


   resource_from_index_base (index : INTEGER_16) : POINTER is
      do
         Result := c_alias_resource_from_index_base( opaque_pointer, index )
      end


   move_category_base (to_category : INTEGER_16; 
		       from_category : INTEGER_16; 
		       set_is_dirty : BOOLEAN) : INTEGER_16 is
      do
         Result := c_alias_move_category_base( opaque_pointer, to_category, from_category, set_is_dirty )
      end


   move_record_base (from_index : INTEGER_16; 
		     to_index : INTEGER_16) : INTEGER_16 is
      do
         Result := c_alias_move_record_base( opaque_pointer, from_index, to_index )
      end

   max_record_index : INTEGER_16 is
      --use this when adding a record to the end of a database
      external "C inline use <DataMgr.h>"
      alias "dmMaxRecordIndex"
      end
   
   number_of_records  : INTEGER_16 is
      do
         Result := c_alias_number_of_records( opaque_pointer )
      end


   number_of_records_in_category (category : INTEGER_16) : INTEGER_16 is
      do
         Result := c_alias_number_of_records_in_category( opaque_pointer, category )
      end


   number_of_resources  : INTEGER_16 is
      do
         Result := c_alias_number_of_resources( opaque_pointer )
      end


   get_info_base (p_localid : POINTER; 
		  p_opencount : POINTER; 
		  p_mode : POINTER; 
		  p_card_number : POINTER; 
		  p_is_resource : POINTER) : INTEGER_16 is
      do
         Result := c_alias_get_info_base( opaque_pointer, p_localid, p_opencount, p_mode, p_card_number, p_is_resource )
      end


   position_in_category (index : INTEGER_16; 
			 category : INTEGER_16) : INTEGER_16 is
      do
         Result := c_alias_position_in_category( opaque_pointer, index, category )
      end


   query_record_base (index : INTEGER_16) : POINTER is
      do
         Result := c_alias_query_record_base( opaque_pointer, index )
      end


   record_info_base (index : INTEGER_16; 
		     p_attr, p_id, p_chunk : POINTER) : INTEGER_16 is
      do
         Result := c_alias_record_info_base( opaque_pointer, index, p_attr, p_id, p_chunk )
      end


   release_record_at_index_base (index : INTEGER_16; 
				 set_is_dirty : BOOLEAN) : INTEGER_16 is
      do
         Result := c_alias_release_record_at_index_base( opaque_pointer, index, set_is_dirty )
      end


   remove_record_at_index_base (index : INTEGER_16) : INTEGER_16 is
      do
         Result := c_alias_remove_record_at_index_base( opaque_pointer, index )
      end


   remove_resource_at_index_base (index : INTEGER_16) : INTEGER_16 is
      do
         Result := c_alias_remove_resource_at_index_base( opaque_pointer, index )
      end


   remove_secret_records_base  : INTEGER_16 is
      do
         Result := c_alias_remove_secret_records_base( opaque_pointer )
      end



feature {ANY} -- aliased helper features for above
   c_alias_archive_record_base (p : POINTER; index : INTEGER_16) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmArchiveRecord"
      end

   c_alias_close_base (p : POINTER) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmCloseDatabase"
      end

   c_alias_delete_category_base (p : POINTER; 
				 category_number : INTEGER_16) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmDeleteCategory"
      end

   c_alias_delete_record_base (p : POINTER; index : INTEGER_16) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmDeleteRecord"
      end

   c_alias_application_info_id_base (p : POINTER) : POINTER is
      external "C use <DataMgr.h>"
      alias "DmGetAppInfoID"
      end

   c_alias_record_from_index_base (p : POINTER; index : INTEGER_16) : POINTER is
      external "C use <DataMgr.h>"
      alias "DmGetRecord"
      end

   c_alias_resource_from_index_base (p : POINTER; index : INTEGER_16) : POINTER is
      external "C use <DataMgr.h>"
      alias "DmGetResourceIndex"
      end

   c_alias_move_category_base (p : POINTER; to_category : INTEGER_16; from_category : INTEGER_16; set_is_dirty : BOOLEAN) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmMoveCategory"
      end

   c_alias_move_record_base (p : POINTER; from_index : INTEGER_16; to_index : INTEGER_16) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmMoveRecord"
      end

   c_alias_number_of_records (p : POINTER) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmNumRecords"
      end

   c_alias_number_of_records_in_category (p : POINTER; category : INTEGER_16) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmNumRecordsInCategory"
      end

   c_alias_number_of_resources (p : POINTER) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmNumResources"
      end

   c_alias_get_info_base ( p, p_localid, p_opencount, 
			   p_mode, p_card_number, 
			   p_is_resource : POINTER) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmOpenDatabaseInfo"
      end

   c_alias_position_in_category (p : POINTER; index : INTEGER_16; category : INTEGER_16) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmPositionInCategory"
      end

   c_alias_query_record_base (p : POINTER; index : INTEGER_16) : POINTER is
      external "C use <DataMgr.h>"
      alias "DmQueryRecord"
      end

   c_alias_record_info_base ( p : POINTER; 
			      index : INTEGER_16; 
			      p_attr, p_id, p_chunk : POINTER) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmRecordInfo"
      end

   c_alias_release_record_at_index_base ( p : POINTER; 
					  index : INTEGER_16; 
					  set_is_dirty : BOOLEAN) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmReleaseRecord"
      end

   c_alias_remove_record_at_index_base ( p : POINTER; 
					 index : INTEGER_16) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmRemoveRecord"
      end

   c_alias_remove_resource_at_index_base ( p : POINTER; 
					   index : INTEGER_16) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmRemoveResource"
      end

   c_alias_remove_secret_records_base (p : POINTER) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmRemoveSecretRecords"
      end


feature {ANY} -- aliased C features

feature {ANY} -- data features

feature {ANY} -- c_without_pointer features

feature {NONE} -- data feature support functions

feature {NONE} -- c_with_pointer feature support functions
   c_dm_find_record_by_id(  db : POINTER; 
			    id : INTEGER_32; 
			    p_index : POINTER ) : INTEGER_16 is
      external "C use <DataMgr.h>"
      alias "DmFindRecordById"
      end
   
   c_dm_new_handle( db : POINTER; size : INTEGER_32 ) : POINTER is
      external "C use <DataMgr.h>"
      alias "DmNewHandle"
      end
   
   c_dm_new_record( db, p_new_index : POINTER; 
		    size : INTEGER_32 ) : POINTER is
      external "C use <DataMgr.h>"
      alias "DmNewRecord"
      end
   
   c_dm_resize_record( db: POINTER; 
		       index : INTEGER_16; 
		       new_size : INTEGER_32 ) : POINTER is
      external "C use <DataMgr.h>"
      alias "DmResizeRecord"
      end
   


feature {NONE} -- c_without_pointer feature support functions

end
