

indexing
   contents: "generated wrapper for C type EventType"
   author: "Victor B. Putz"
   completed: no
   tested: no
   

class EVENT
inherit
   C_STRUCT
      redefine
	 structure_size
      end

   
creation
   from_shared_memory, from_orphaned_memory, as_new_memory
   
feature {ANY} -- direct Eiffel features

   structure_size : INTEGER_32 is
      external "C inline use <Event.h>"
	 alias "sizeof(EventType)"
	 end

   data_ctlselect_control : FORM_CONTROL is
      do
         create Result.from_shared_memory( data_ctlselect_pcontrol )
      end


   data_popselect_control : FORM_CONTROL is
      do
         create Result.from_shared_memory( data_popselect_pcontrol )
      end


  data_popselect_list : FORM_LIST is
      do
         create Result.from_shared_memory( data_popselect_plist )
      end


   data_listselect_list : FORM_LIST is
      do
         create Result.from_shared_memory( data_listselect_plist )
      end


   data_tblenter_table : FORM_TABLE is
      do
         create Result.from_shared_memory( data_tblenter_ptable )
      end


   data_tblexit_table : FORM_TABLE is
      do
         create Result.from_shared_memory( data_tblexit_ptable )
      end


   data_tblselect_table : FORM_TABLE is
      do
         create Result.from_shared_memory( data_tblselect_ptable )
      end


   data_fldenter_field : FORM_FIELD is
      do
         create Result.from_shared_memory( data_fldenter_pfield )
      end


   data_fldheightchanged_field : FORM_FIELD is
      do
         create Result.from_shared_memory( data_fldheightchanged_pfield )
      end


   data_fldchanged_field : FORM_FIELD is
      do
         create Result.from_shared_memory( data_fldchanged_pfield )
      end


   data_fldexit_field : FORM_FIELD is
      do
         create Result.from_shared_memory( data_fldexit_pfield )
      end


   data_sclenter_scrollbar : FORM_SCROLLBAR is 
      do
         create Result.from_shared_memory( data_sclenter_pscrollbar )
      end


   data_sclexit_scrollbar : FORM_SCROLLBAR is 
      do
         create Result.from_shared_memory( data_sclexit_pscrollbar )
      end


   data_sclrepeat_scrollbar : FORM_SCROLLBAR is 
      do
         create Result.from_shared_memory( data_sclrepeat_pscrollbar )
      end


feature {ANY} -- structure features (aliased)
   add_to_queue   is
      do
         c_alias_add_to_queue( opaque_pointer )
      end


   get ( timeout : INTEGER_32 )  is
      do
         c_alias_get( opaque_pointer, timeout )
      end



feature {ANY} -- aliased helper features for above
   c_alias_add_to_queue (p : POINTER)  is
      external "C use <Event.h>"
      alias "EvtAddEventToQueue"
      end

   c_alias_get (p : POINTER; timeout : INTEGER_32)  is
      external "C use <Event.h>"
      alias "EvtGetEvent"
      end


feature {ANY} -- aliased C features
   is_available  : boolean is
      external "C use <Event.h>"
      alias "EvtEventAvail"
      end


feature {ANY} -- data features
   type : INTEGER_16 is do
      Result := c_event_type( opaque_pointer ) 
   end

   pen_down : INTEGER_16 is do
      Result := c_event_pen_down( opaque_pointer ) 
   end

   screen_x : INTEGER_16 is do
      Result := c_event_screen_x( opaque_pointer ) 
   end

   screen_y : INTEGER_16 is do
      Result := c_event_screen_y( opaque_pointer ) 
   end

   data_ctlselect_controlid : INTEGER_16 is do
      Result := c_event_data_ctlselect_controlid( opaque_pointer ) 
   end

   data_ctlselect_pcontrol : POINTER is do
      Result := c_event_data_ctlselect_pcontrol( opaque_pointer ) 
   end

   data_popselect_controlid : INTEGER_16 is do
      Result := c_event_data_popselect_controlid( opaque_pointer ) 
   end

   data_popselect_pcontrol : POINTER is do
      Result := c_event_data_popselect_pcontrol( opaque_pointer ) 
   end

   data_popselect_listid : INTEGER_16 is do
      Result := c_event_data_popselect_listid( opaque_pointer ) 
   end

   data_popselect_plist : POINTER is do
      Result := c_event_data_popselect_plist( opaque_pointer ) 
   end

   data_popselect_selection : INTEGER_16 is do
      Result := c_event_data_popselect_selection( opaque_pointer ) 
   end

   data_popselect_prior_selection : INTEGER_16 is do
      Result := c_event_data_popselect_prior_selection( opaque_pointer ) 
   end

   data_listenter_listid : INTEGER_16 is do
      Result := c_event_data_listenter_listid( opaque_pointer ) 
   end

   data_listenter_plist : POINTER is do
      Result := c_event_data_listenter_plist( opaque_pointer ) 
   end

   data_listenter_selection : INTEGER_16 is do
      Result := c_event_data_listenter_selection( opaque_pointer ) 
   end

   listexit_listid : INTEGER_16 is do
      Result := c_event_listexit_listid( opaque_pointer ) 
   end

   data_listexit_plist : POINTER is do
      Result := c_event_data_listexit_plist( opaque_pointer ) 
   end

   data_listselect_listid : INTEGER_16 is do
      Result := c_event_data_listselect_listid( opaque_pointer ) 
   end

   data_listselect_plist : POINTER is do
      Result := c_event_data_listselect_plist( opaque_pointer ) 
   end

   data_listselect_selection : INTEGER_16 is do
      Result := c_event_data_listselect_selection( opaque_pointer ) 
   end

   data_tblenter_tableid : INTEGER_16 is do
      Result := c_event_data_tblenter_tableid( opaque_pointer ) 
   end

   data_tblenter_ptable : POINTER is do
      Result := c_event_data_tblenter_ptable( opaque_pointer ) 
   end

   data_tblenter_row : INTEGER_16 is do
      Result := c_event_data_tblenter_row( opaque_pointer ) 
   end

   data_tblenter_column : INTEGER_16 is do
      Result := c_event_data_tblenter_column( opaque_pointer ) 
   end

   data_tblexit_tableid : INTEGER_16 is do
      Result := c_event_data_tblexit_tableid( opaque_pointer ) 
   end

   data_tblexit_ptable : POINTER is do
      Result := c_event_data_tblexit_ptable( opaque_pointer ) 
   end

   data_tblexit_row : INTEGER_16 is do
      Result := c_event_data_tblexit_row( opaque_pointer ) 
   end

   data_tblexit_column : INTEGER_16 is do
      Result := c_event_data_tblexit_column( opaque_pointer ) 
   end

   data_tblselect_tableid : INTEGER_16 is do
      Result := c_event_data_tblselect_tableid( opaque_pointer ) 
   end

   data_tblselect_ptable : POINTER is do
      Result := c_event_data_tblselect_ptable( opaque_pointer ) 
   end

   data_tblselect_row : INTEGER_16 is do
      Result := c_event_data_tblselect_row( opaque_pointer ) 
   end

   data_tblselect_column : INTEGER_16 is do
      Result := c_event_data_tblselect_column( opaque_pointer ) 
   end

   data_ctlrepeat_controlid : INTEGER_16 is do
      Result := c_event_data_ctlrepeat_controlid( opaque_pointer ) 
   end

   data_frmload_formid : INTEGER_16 is 
      do
	 Result := c_event_data_frmload_formid( opaque_pointer );
      end
   
   data_fldenter_field_id : INTEGER_16 is do
      Result := c_event_data_fldenter_field_id( opaque_pointer ) 
   end

   data_fldenter_pfield : POINTER is do
      Result := c_event_data_fldenter_pfield( opaque_pointer ) 
   end

   data_fldheightchanged_fieldid : INTEGER_16 is do
      Result := c_event_data_fldheightchanged_fieldid( opaque_pointer ) 
   end

   data_fldheightchanged_pfield : POINTER is do
      Result := c_event_data_fldheightchanged_pfield( opaque_pointer ) 
   end

   data_fldheightchanged_newheight : INTEGER_16 is do
      Result := c_event_data_fldheightchanged_newheight( opaque_pointer ) 
   end

   data_fldheightchanged_currentpos : INTEGER_16 is do
      Result := c_event_data_fldheightchanged_currentpos( opaque_pointer ) 
   end

   data_fldchanged_fieldid : INTEGER_16 is do
      Result := c_event_data_fldchanged_fieldid( opaque_pointer ) 
   end

   data_fldchanged_pfield : POINTER is do
      Result := c_event_data_fldchanged_pfield( opaque_pointer ) 
   end

   data_fldexit_fieldid : INTEGER_16 is do
      Result := c_event_data_fldexit_fieldid( opaque_pointer ) 
   end

   data_fldexit_pfield : POINTER is do
      Result := c_event_data_fldexit_pfield( opaque_pointer ) 
   end

   data_sclenter_scrollbarid : INTEGER_16 is do
      Result := c_event_data_sclenter_scrollbarid( opaque_pointer ) 
   end

   data_sclenter_pscrollbar : POINTER is do
      Result := c_event_data_sclenter_pscrollbar( opaque_pointer ) 
   end

   data_sclexit_scrollbarid : INTEGER_16 is do
      Result := c_event_data_sclexit_scrollbarid( opaque_pointer ) 
   end

   data_sclexit_pscrollbar : POINTER is do
      Result := c_event_data_sclexit_pscrollbar( opaque_pointer ) 
   end

   data_sclexit_value : INTEGER_16 is do
      Result := c_event_data_sclexit_value( opaque_pointer ) 
   end

   data_sclexit_newvalue : INTEGER_16 is do
      Result := c_event_data_sclexit_newvalue( opaque_pointer ) 
   end

   data_sclrepeat_scrollbarid : INTEGER_16 is do
      Result := c_event_data_sclrepeat_scrollbarid( opaque_pointer ) 
   end

   data_sclrepeat_pscrollbar : POINTER is do
      Result := c_event_data_sclrepeat_pscrollbar( opaque_pointer ) 
   end

   data_sclrepeat_value : INTEGER_16 is do
      Result := c_event_data_sclrepeat_value( opaque_pointer ) 
   end

   data_sclrepeat_newvalue : INTEGER_16 is do
      Result := c_event_data_sclrepeat_newvalue( opaque_pointer ) 
   end

   data_sclrepeat_time : INTEGER_16 is do
      Result := c_event_data_sclrepeat_time( opaque_pointer ) 
   end

   data_menu_item_id : INTEGER_16 is do
      Result := c_event_data_menu_item_id( opaque_pointer ) 
   end

   data_keydown_chr : INTEGER_16 is do
      Result := c_event_data_keydown_chr( opaque_pointer ) 
   end

   data_keydown_keycode : INTEGER_16 is do
      Result := c_event_data_keydown_keycode( opaque_pointer ) 
   end

   data_keydown_modifiers : INTEGER_16 is do
      Result := c_event_data_keydown_modifiers( opaque_pointer ) 
   end


feature {ANY} -- c_with_pointer features

feature {ANY} -- c_without_pointer features

feature {NONE} -- data feature support functions
   c_event_type( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get eType use <Event.h>"
      end

   c_event_pen_down( p : POINTER ) : BOOLEAN is 
      external "C struct EventType get penDown use <Event.h>" 
      end
   
   c_event_tap_count( p : POINTER ) : INTEGER_8 is
      external "C struct EventType get tapCount use <Event.h>"
      end

   c_event_screen_x( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get screenX use <Event.h>" 
      end

   c_event_screen_y( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get screenY use <Event.h>" 
      end

   c_event_data_ctlselect_controlid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.ctlSelect.controlID use <Event.h>" 
      end

   c_event_data_ctlselect_pcontrol( p : POINTER ) : POINTER is 
      external "C struct EventType get data.ctlSelect.pControl use <Event.h>" 
      end

   c_event_data_popselect_controlid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.popSelect.controlID use <Event.h>" 
      end

   c_event_data_popselect_pcontrol( p : POINTER ) : POINTER is 
      external "C struct EventType get data.popSelect.controlP use <Event.h>" 
      end

   c_event_data_popselect_listid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.popSelect.listID use <Event.h>" 
      end

   c_event_data_popselect_plist( p : POINTER ) : POINTER is 
      external "C struct EventType get data.popSelect.listP use <Event.h>" 
      end

   c_event_data_popselect_selection( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.popSelect.selection use <Event.h>" 
      end

   c_event_data_popselect_prior_selection( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.popSelect.priorSelection use <Event.h>" 
      end

   c_event_data_listenter_listid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.lstEnter.listID use <Event.h>"  
      end

   c_event_data_listenter_plist( p : POINTER ) : POINTER is 
      external "C struct EventType get data.lstEnter.pList use <Event.h>"  
      end

   c_event_data_listenter_selection( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.lstEnter.selection use <Event.h>"  
      end

   c_event_listexit_listid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.lstExit.listID use <Event.h>"  
      end

   c_event_data_listexit_plist( p : POINTER ) : POINTER is 
      external "C struct EventType get data.lstExit.pList use <Event.h>"  
      end

   c_event_data_listselect_listid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.lstSelect.listID use <Event.h>"  
      end
   
   c_event_data_listselect_plist( p : POINTER ) : POINTER is 
      external "C struct EventType get data.lstSelect.pList use <Event.h>"  
      end

   c_event_data_listselect_selection( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.lstSelect.selection use <Event.h>"  
      end

   c_event_data_tblenter_tableid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.tblEnter.tableID use <Event.h>"  
      end

   c_event_data_tblenter_ptable( p : POINTER ) : POINTER is 
      external "C struct EventType get data.tblEnter.pTable use <Event.h>"  
      end

   c_event_data_tblenter_row( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.tblEnter.row use <Event.h>"  
      end

   c_event_data_tblenter_column( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.tblEnter.column use <Event.h>"  
      end

   c_event_data_tblexit_tableid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.tblExit.tableID use <Event.h>"  
      end

   c_event_data_tblexit_ptable( p : POINTER ) : POINTER is 
      external "C struct EventType get data.tblExit.pTable use <Event.h>"  
      end

   c_event_data_tblexit_row( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.tblExit.row use <Event.h>"  
      end

   c_event_data_tblexit_column( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.tblExit.column use <Event.h>"  
      end

   c_event_data_tblselect_tableid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.tblSelect.tableID use <Event.h>"  
      end

   c_event_data_tblselect_ptable( p : POINTER ) : POINTER is 
      external "C struct EventType get data.tblSelect.pTable use <Event.h>"  
      end

   c_event_data_tblselect_row( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.tblSelect.row use <Event.h>"  
      end

   c_event_data_tblselect_column( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.tblSelect.column use <Event.h>"  
      end

   c_event_data_ctlrepeat_controlid( p : POINTER ) : INTEGER_16 is
      external "C struct EventType get data.ctlRepeat.controlID use <Event.h>"
      end
   
   c_event_data_frmload_formid( p : POINTER) : INTEGER_16 is
      external "C struct EventType get data.frmLoad.formID use <Event.h>"
      end

   c_event_data_fldenter_field_id( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.fldEnter.fieldID use <Event.h>"
      end

   c_event_data_fldenter_pfield( p : POINTER ) : POINTER is 
      external "C struct EventType get data.fldEnter.pField use <Event.h>"
      end

   c_event_data_fldheightchanged_fieldid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.fldHeightChanged.fieldId use <Event.h>"
      end

   c_event_data_fldheightchanged_pfield( p : POINTER ) : POINTER is 
      external "C struct EventType get data.fldHeightChanged.pField use <Event.h>"
      end

   c_event_data_fldheightchanged_newheight( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.fldHeightChanged.newHeight use <Event.h>"
      end
   
   c_event_data_fldheightchanged_currentpos( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.fldHeightChanged.currentPos use <Event.h>"
      end

   c_event_data_fldchanged_fieldid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.fldChanged.fieldID use <Event.h>"
      end

   c_event_data_fldchanged_pfield( p : POINTER ) : POINTER is 
      external "C struct EventType get data.fldChanged.pField use <Event.h>"
      end

   c_event_data_sclenter_scrollbarid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.sclEnter.scrollBarID use <Event.h>"
      end

   c_event_data_sclenter_pscrollbar( p : POINTER ) : POINTER is 
      external "C struct EventType get data.sclEnter.pScrollBar use <Event.h>"
      end

   c_event_data_sclexit_scrollbarid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.sclExit.scrollBarID use <Event.h>"
      end
   
   c_event_data_sclexit_pscrollbar( p : POINTER ) : POINTER is 
      external "C struct EventType get data.sclExit.pScrollBar use <Event.h>"
      end

   c_event_data_sclexit_value( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.sclExit.value use <Event.h>"
      end

   c_event_data_sclexit_newvalue( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.sclExit.newValue use <Event.h>"
      end

   c_event_data_sclrepeat_scrollbarid( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.sclRepeat.scrollBarID use <Event.h>"
      end

   c_event_data_sclrepeat_pscrollbar( p : POINTER ) : POINTER is 
      external "C struct EventType get data.sclRepeat.pScrollBar use <Event.h>"
      end

   c_event_data_sclrepeat_value( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.sclRepeat.value use <Event.h>"
      end

   c_event_data_sclrepeat_newvalue( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.sclRepeat.newValue use <Event.h>"
      end

   c_event_data_sclrepeat_time( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.sclRepeat.time use <Event.h>"
      end

   c_event_data_menu_item_id( p : POINTER ) : INTEGER_16 is
      external "C struct EventType get data.menu.itemID use <Event.h>"
      end

   c_event_data_keydown_chr( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.keyDown.chr use <Event.h>"
      end

   c_event_data_keydown_keycode( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.keyDown.keyCode use <Event.h>"
      end

   c_event_data_keydown_modifiers( p : POINTER ) : INTEGER_16 is 
      external "C struct EventType get data.keyDown.modifiers use <Event.h>"
      end

feature {NONE} -- c_with_pointer feature support functions

feature {NONE} -- c_without_pointer feature support functions

end
