indexing
   contents : "Wraps 'control' form objects--buttons, popup triggers, selectors, repeating buttons, sliders, etc."
   author : "Victor B. Putz"
   completed : no
   tested : no
   
class FORM_CONTROL
   
inherit
   FORM_OBJECT
   redefine
      structure_size
      end
      
creation
   from_shared_memory, from_orphaned_memory, as_new_memory
      
feature {ANY}
   
   structure_size : INTEGER_32 is
      do
	 Result := c_form_control_structure_size
      end
   
   draw is
      do
	 c_form_control_draw_control( opaque_pointer )
      end
   
   is_enabled : BOOLEAN is
      do
	 Result := c_form_control_is_enabled( opaque_pointer )
      end
   
   set_enabled( new_is_enabled : BOOLEAN ) is
      do
	 c_form_control_set_enabled( opaque_pointer, new_is_enabled );
      end
   
   erase is
      do
	 c_form_control_erase_control( opaque_pointer )
      end
   
   label : STRING is
      do
	 create Result.from_external_copy( c_form_control_get_label( opaque_pointer ))
      end
   
   set_label( new_label : STRING ) is 
	 --sets the control label--this JUST stores the to_external 
	 --pointer in the control, so you must keep the string around 
	 --(live) and unchanged.
      do
	 c_form_control_set_label( opaque_pointer, new_label.to_external )
      end
   
   last_event_was_handled : BOOLEAN
   
   handle_event( event : EVENT ) is
      do
	 last_event_was_handled := c_form_control_handle_event( opaque_pointer, event.opaque_pointer )
      end
   
   hide is
      do
	 c_form_control_hide_control( opaque_pointer )
      end
   
   hit is
      do
	 c_form_control_hit_control( opaque_pointer )
      end
   
   set_usable( new_is_usable : BOOLEAN ) is
      do
	 c_form_control_set_usable( opaque_pointer, new_is_usable )
      end
   
   value : INTEGER_16 is
      do
	 Result := c_form_control_get_value( opaque_pointer )
      end

   set_value( new_value : INTEGER_16 ) is
      do
	 c_form_control_set_value( opaque_pointer, new_value )
      end
   
   show is
      do
	 c_form_control_show_control( opaque_pointer )
      end
   
   is_valid : BOOLEAN is
      do
	 Result := c_form_control_validate_pointer( opaque_pointer )
      end
   
feature {NONE} -- c interface functions
   
   c_form_control_structure_size : INTEGER_32 is
      external "C inline"
      alias "(sizeof (ControlType) )"
      end
   
   c_form_control_draw_control( p : POINTER ) is
      external "C use <Control.h>"
      alias "CtlDrawControl"
      end
	 
   c_form_control_is_enabled( p : POINTER ) : BOOLEAN is
      external "C use <Control.h>"
      alias "CtlEnabled"
      end
	 
   c_form_control_set_enabled( p : POINTER; new_is_enabled : BOOLEAN ) is
      external "C use <Control.h>"
      alias "CtlSetEnabled"
      end
   
   c_form_control_erase_control( p : POINTER ) is
      external "C use <Control.h>"
      alias "CtlEraseControl"
      end
   
   c_form_control_get_label( p : POINTER ) : POINTER is
      external "C use <Control.h>"
      alias "CtlGetLabel"
      end
   
   c_form_control_set_label( p_control, p_label : POINTER ) is
      external "C use <Control.h>"
      alias "CtlSetLabel"
      end
   
   c_form_control_handle_event( p, event_p : POINTER ) : BOOLEAN is
      external "C use <Control.h>"
      alias "CtlHandleEvent"
      end
   
   c_form_control_hide_control( p : POINTER ) is
      external "C use <Control.h>"
      alias "CtlHideControl"
      end
   
   c_form_control_hit_control( p : POINTER ) is
      external "C use <Control.h>"
      alias "CtlHitControl"
      end
   
   c_form_control_set_usable( p : POINTER; new_is_usable : BOOLEAN ) is
      external "C use <Control.h>"
      alias "CtlSetUsable"
      end
   
   c_form_control_get_value( p : POINTER ) : INTEGER_16 is
      external "C use <Control.h>"
      alias "CtlGetValue"
      end
   
   c_form_control_set_value( p : POINTER; new_value : INTEGER_16 ) is
      external "C use <Control.h>"
      alias "CtlSetValue"
      end
   
   c_form_control_show_control( p : POINTER ) is
      external "C use <Control.h>"
      alias "CtlShowControl"
      end
   
   c_form_control_validate_pointer( p : POINTER ) : BOOLEAN is
      external "C use <Control.h>"
      alias "CtlValidatePointer"
      end
   
end
   
