

indexing
   contents: "generated wrapper for C type ScrollBarType"
   author: "Victor B. Putz"
   completed: no
   tested: no
   

class FORM_SCROLLBAR
inherit
   C_STRUCT
      redefine
	 structure_size
      end

   
creation
   from_shared_memory, from_orphaned_memory, as_new_memory
   
feature {ANY} -- direct Eiffel features

   structure_size : INTEGER_32 is
      do
         Result := c_form_scrollbar_structure_size
      end


   c_form_scrollbar_structure_size : INTEGER_32 is 
      external "C inline" 
      alias "(sizeof (ScrollBarType))"
      end


   last_event_was_handled : BOOLEAN
   
   handle_event( event : EVENT ) is 
      do
         last_event_was_handled := c_form_scrollbar_handle_event_ptr( opaque_pointer, event.opaque_pointer )
      end


   set_values( new_value, new_min, new_max, new_page_size : INTEGER_16 ) is
      do
	 c_form_scrollbar_set_values( opaque_pointer, new_value, new_min, new_max, new_page_size )
      end
   
   set_scrollbar_values( new_values : SCROLLBAR_VALUES ) is
      do
         set_values( new_values.value, new_values.min, new_values.max, new_values.page_size )
      end


   c_form_scrollbar_get_value( p : POINTER; index : INTEGER_16 ) : INTEGER_16 is
      external "C"
      end
   
   value : INTEGER_16 is
      do
	 Result := c_form_scrollbar_get_value( opaque_pointer, 0 )
      end
   
   min : INTEGER_16 is
      do
	 Result := c_form_scrollbar_get_value( opaque_pointer, 1 )
      end
   
   max : INTEGER_16 is
      do
	 Result := c_form_scrollbar_get_value( opaque_pointer, 2 )
      end
   
   page_size : INTEGER_16 is
      do
	 Result := c_form_scrollbar_get_value( opaque_pointer, 3 )
      end
   
   scrollbar_values : SCROLLBAR_VALUES is
      do
         create Result
         Result.set_values( value, min, max, page_size )
      end


feature {ANY} -- structure features (aliased)
   draw   is
      do
         c_alias_draw( opaque_pointer )
      end



feature {ANY} -- aliased helper features for above
   c_alias_draw (p : POINTER)  is
      external "C use <ScrollBar.h>"
      alias "SclDrawScrollBar"
      end


feature {ANY} -- aliased C features
   c_form_scrollbar_handle_event_ptr (p_scrollbar : POINTER; p_event : POINTER) : BOOLEAN is
      external "C use <ScrollBar.h>"
      alias "SclHandleEvent"
      end

   c_form_scrollbar_set_values ( p : POINTER; 
				 new_value, new_min, new_max,
				 new_page_size : INTEGER_16)  is
      external "C use <ScrollBar.h>"
      alias "SclSetScrollBar"
      end


feature {ANY} -- data features

feature {ANY} -- c_with_pointer features

feature {ANY} -- c_without_pointer features

feature {NONE} -- data feature support functions

feature {NONE} -- c_with_pointer feature support functions

feature {NONE} -- c_without_pointer feature support functions

end
