indexing
   contents : "Wraps slider functionality--pretty much just setting/getting methods"
   author : "Victor B. Putz"
   completed : no
   tested : no
   
class FORM_SLIDER
   
inherit
   FORM_CONTROL
      redefine
	 value, set_value
   
creation
   from_shared_memory, from_orphaned_memory, as_new_memory

feature {ANY}
   
   min_value : INTEGER_16 is
      do
	 Result := c_form_slider_get_slider_value( opaque_pointer, Min_value_tag )
      end

   max_value : INTEGER_16 is
      do
	 Result := c_form_slider_get_slider_value( opaque_pointer, Max_value_tag )
      end 
   
   page_size : INTEGER_16 is
      do
	 Result := c_form_slider_get_slider_value( opaque_pointer, Page_size_tag )
      end
   
   value : INTEGER_16 is
      do
	 Result := c_form_slider_get_value( opaque_pointer, Value_tag )
      end
   
   set_min_value( opaque_pointer, new_value : INTEGER_16 ) is
      do
	 c_form_slider_set_slider_value( opaque_pointer, new_value, Min_value_tag )
      end
   
   set_max_value( opaque_pointer, new_value : INTEGER_16 ) is
      do
	 c_form_slider_set_slider_value( opaque_pointer, new_value, Max_value_tag )
      end
   
   set_page_size( new_value : INTEGER_16 ) is
      do
	 c_form_slider_set_slider_value( opaque_pointer, new_value, Page_size_tag )
      end
   
   set_value( opaque_pointer, new_value : INTEGER_16 ) is
      do
	 c_form_slider_set_slider_value( opaque_pointer, new_value, Value_tag )
      end
   
feature {NONE} -- c code access constants   
   
   Min_value_tag : INTEGER_16 is 1
   Max_value_tag : INTEGER_16 is 2
   Page_size_tag : INTEGER_16 is 3
   Value_tag     : INTEGER_16 is 4
   
feature {NONE} -- c code
   
   c_form_slider_set_slider_value( p: POINTER; new_value, tag : INTEGER_16 ) is
      external "C"
      end
   
   c_form_slider_get_slider_value( p : POINTER; tag : INTEGER_16 ) : INTEGER_16 is
      external "C"
      end
   
end

	
