

indexing
   contents: "generated wrapper for C type TableType"
   author: "Victor B. Putz"
   completed: no
   tested: no
   

class FORM_TABLE
inherit
   C_STRUCT
      redefine
	 structure_size
      end

   FEATURE_MANAGER
   TABLE_DISPATCHER_CLIENT

   
creation
   from_shared_memory, from_orphaned_memory, as_new_memory
   
feature {ANY} -- direct Eiffel features

   structure_size : INTEGER_32 is
      do
         Result := c_table_structure_size
      end


   c_table_structure_size : INTEGER_32 is 
      external "C inline use <Table.h>"
      alias "sizeof( TableType )"
      end

   bounds : PALM_RECTANGLE is
      do
         create Result.as_new_memory
         c_form_table_get_bounds( opaque_pointer, Result.opaque_pointer )
      end


   current_field : FORM_FIELD is
      do
         create Result.from_shared_memory( c_form_table_current_field( opaque_pointer ) )
      end


   item_bounds( row, column : INTEGER_16) : PALM_RECTANGLE is
      do
         create Result.as_new_memory
         c_form_table_item_bounds( opaque_pointer, row, column, Result.opaque_pointer );
      end


   item_pointer( row, column : INTEGER_16) : POINTER is
      do
         if feature_set_3_5_is_implemented then
            Result := item_pointer_base_os( row, column )
         else
            Result := item_pointer_base_struct( row, column )
         end
      end


   last_selected_row : INTEGER_16
   last_selected_column : INTEGER_16
   last_selection_was_highlighted : BOOLEAN
   get_selection is
      do
         last_selection_was_highlighted := get_selection_base( $last_selected_row, $last_selected_column )
      end



   last_event_was_handled : BOOLEAN
   
   handle_event( event : EVENT ) is
      do
         last_event_was_handled := handle_event_base( event.opaque_pointer )
      end


   set_bounds( new_bounds : PALM_RECTANGLE ) is
      do
         c_tbl_set_bounds( opaque_pointer, new_bounds.opaque_pointer )
      end


   draw_item( row, column : INTEGER_16; drawn_item_bounds : PALM_RECTANGLE ) is do end
      --redefine this in descendant classes for custom drawing of elements,
      --and register the table with the global TABLE_DISPATCHER object.  See
      --PalmOS documentation for TableDrawItemFuncType


   last_load_data_was_successful : BOOLEAN
      --whether or not the last call to load_data was successful

   last_load_data_handle : MEM_HANDLE
      --handle containing the data last loaded

   last_load_data_offset : INTEGER_16
      --offset in last_load_data_handle of zero-terminated string containing table data

   last_load_data_size : INTEGER_16
      --size of last loaded table data

   load_data( row, column : INTEGER_16; is_editable : BOOLEAN; field : FORM_FIELD ) is do end
      --customized load data function.  Redefine this in descendant classes
      --and register the table with the global TABLE_DISPATCHER object.  This
      --function should set the four last_load_* members after complete.  See
      --PalmOS documentation on TableLoadDataFuncType


   table_should_be_redrawn_after_save : BOOLEAN

   save_data( row, column : INTEGER_16) is do end
      --Redefine this in descendant classes and register the table
      --with the global TABLE_DISPATCHER object; it should set the
      --table_should_be_redrawn_after_save member after complete.
      --see PalmOS Documentation on TableSaveDataFuncType


feature {ANY} -- structure features (aliased)
   draw   is
      do
         c_alias_draw( opaque_pointer )
      end


   erase   is
      do
         c_alias_erase( opaque_pointer )
      end


   is_editing  : BOOLEAN is
      do
         Result := c_alias_is_editing( opaque_pointer )
      end


   column_spacing (column : INTEGER_16 ): INTEGER_16 is
      do
         Result := c_alias_column_spacing( opaque_pointer, column )
      end


   column_width (column : INTEGER_16) : INTEGER_16 is
      do
         Result := c_alias_column_width( opaque_pointer, column )
      end


   item_font (row : INTEGER_16; column : INTEGER_16 ): INTEGER_16 is
      do
         Result := c_alias_item_font( opaque_pointer, row, column )
      end


   item_integer (row : INTEGER_16; column : INTEGER_16 ): INTEGER_16 is
      do
         Result := c_alias_item_integer( opaque_pointer, row, column )
      end


   item_pointer_base_os (row : INTEGER_16; column : INTEGER_16 ): POINTER is
      do
         Result := c_alias_item_pointer_base_os( opaque_pointer, row, column )
      end


   last_usable_row  : INTEGER_16 is
      do
         Result := c_alias_last_usable_row( opaque_pointer )
      end
   
   number_of_columns : INTEGER_16 is
      do
	 Result := c_alias_number_of_columns( opaque_pointer )
      end

   number_of_rows  : INTEGER_16 is
      do
         Result := c_alias_number_of_rows( opaque_pointer )
      end


   row_data (row : INTEGER_16 ): INTEGER_32 is
      do
         Result := c_alias_row_data( opaque_pointer, row )
      end


   row_height (row : INTEGER_16 ): INTEGER_16 is
      do
         Result := c_alias_row_height( opaque_pointer, row )
      end


   row_id (row : INTEGER_16 ): INTEGER_16 is
      do
         Result := c_alias_row_id( opaque_pointer, row )
      end


   get_selection_base (p_row : POINTER; p_column : POINTER) : BOOLEAN is
      do
         Result := c_alias_get_selection_base( opaque_pointer, p_row, p_column )
      end


   grab_focus (row : INTEGER_16; column : INTEGER_16 ) is
      do
         c_alias_grab_focus( opaque_pointer, row, column )
      end


   handle_event_base (p_event : POINTER) : BOOLEAN is
      do
         Result := c_alias_handle_event_base( opaque_pointer, p_event )
      end


   set_has_scroll_bar (new_has_scroll_bar : BOOLEAN)  is
      do
         c_alias_set_has_scroll_bar( opaque_pointer, new_has_scroll_bar )
      end


   insert_row (row : INTEGER_16 ) is
      do
         c_alias_insert_row( opaque_pointer, row )
      end


   mark_row_invalid (row : INTEGER_16)  is
      do
         c_alias_mark_row_invalid( opaque_pointer, row )
      end


   mark_table_invalid   is
      do
         c_alias_mark_table_invalid( opaque_pointer )
      end


   redraw   is
      do
         c_alias_redraw( opaque_pointer )
      end


   release_focus   is
      do
         c_alias_release_focus( opaque_pointer )
      end


   remove_row (row : INTEGER_16  ) is
      do
         c_alias_remove_row( opaque_pointer, row )
      end


   row_is_invalid (row : INTEGER_16 ): BOOLEAN is
      do
         Result := c_alias_row_is_invalid( opaque_pointer, row )
      end


   row_is_masked (row : INTEGER_16 ): BOOLEAN is
      do
         Result := c_alias_row_is_masked( opaque_pointer, row )
      end


   row_is_selectable (row : INTEGER_16 ): BOOLEAN is
      do
         Result := c_alias_row_is_selectable( opaque_pointer, row )
      end


   row_is_usable (row : INTEGER_16 ): BOOLEAN is
      do
         Result := c_alias_row_is_usable( opaque_pointer, row )
      end


   select_item (row : INTEGER_16; column : INTEGER_16  ) is
      do
         c_alias_select_item( opaque_pointer, row, column )
      end


   set_column_edit_indicator (column : INTEGER_16; new_in_edit_mode : BOOLEAN)  is
      do
         c_alias_set_column_edit_indicator( opaque_pointer, column, new_in_edit_mode )
      end


   set_column_masked (column : INTEGER_16; new_is_masked : BOOLEAN)  is
      do
         c_alias_set_column_masked( opaque_pointer, column, new_is_masked )
      end


   set_column_spacing (column : INTEGER_16; new_spacing : INTEGER_16  ) is
      do
         c_alias_set_column_spacing( opaque_pointer, column, new_spacing )
      end


   set_column_is_usable (column : INTEGER_16; new_is_usable : BOOLEAN)  is
      do
         c_alias_set_column_is_usable( opaque_pointer, column, new_is_usable )
      end


   set_column_width (column : INTEGER_16; new_width : INTEGER_16  ) is
      do
         c_alias_set_column_width( opaque_pointer, column, new_width )
      end


   set_item_font (row, column, new_font : INTEGER_16 ) : INTEGER_16 is 
      do
         c_alias_set_item_font( opaque_pointer, row, column, new_font )
      end


   set_item_integer (row, column, new_int : INTEGER_16 ) is
      do
         c_alias_set_item_integer( opaque_pointer, row, column, new_int )
      end


   set_item_pointer (row, column : INTEGER_16; new_ptr : POINTER)  is
      do
         c_alias_set_item_pointer( opaque_pointer, row, column, new_ptr )
      end


   set_item_style (row, column, new_style : INTEGER_16 )  is
      do
         c_alias_set_item_style( opaque_pointer, row, column, new_style )
      end


   set_row_data (row : INTEGER_16; new_data : INTEGER_32 ) is
      do
         c_alias_set_row_data( opaque_pointer, row, new_data )
      end


   set_row_height (row, new_height : INTEGER_16 )  is
      do
         c_alias_set_row_height( opaque_pointer, row, new_height )
      end


   set_row_id (row, new_id : INTEGER_16 )  is
      do
         c_alias_set_row_id( opaque_pointer, row, new_id )
      end


   set_row_masked (row : INTEGER_16; new_is_masked : BOOLEAN)  is
      do
         c_alias_set_row_masked( opaque_pointer, row, new_is_masked )
      end


   set_row_is_selectable (row : INTEGER_16; new_is_selectable : BOOLEAN)  is
      do
         c_alias_set_row_is_selectable( opaque_pointer, row, new_is_selectable )
      end


   set_row_static_height (row, new_height : INTEGER_16 )  is
      do
         c_alias_set_row_static_height( opaque_pointer, row, new_height )
      end


   set_row_is_usable (row : INTEGER_16; new_is_usable : BOOLEAN)  is
      do
         c_alias_set_row_is_usable( opaque_pointer, row, new_is_usable )
      end


   unhighlight_selection   is
      do
         c_alias_unhighlight_selection( opaque_pointer )
      end



feature {ANY} -- aliased helper features for above
   c_alias_draw (p : POINTER)  is
      external "C use <Table.h>"
      alias "TblDrawTable"
      end

   c_alias_erase (p : POINTER)  is
      external "C use <Table.h>"
      alias "TblEraseTable"
      end

   c_alias_is_editing (p : POINTER) : BOOLEAN is
      external "C use <Table.h>"
      alias "TblEditing"
      end

   c_alias_column_spacing (p : POINTER; column : INTEGER_16) : INTEGER_16 is
      external "C use <Table.h>"
      alias "TblGetColumnSpacing"
      end

   c_alias_column_width (p : POINTER; column : INTEGER_16) : INTEGER_16 is
      external "C use <Table.h>"
      alias "TblGetColumnWidth"
      end

   c_alias_item_font (p : POINTER; row, column:  INTEGER_16) : INTEGER_16 is
      external "C use <Table.h>"
      alias "TblGetItemFont"
      end

   c_alias_item_integer (p : POINTER; row, column : INTEGER_16) : INTEGER_16 is
      external "C use <Table.h>"
      alias "TblGetItemInt"
      end

   c_alias_item_pointer_base_os (p : POINTER; 
				 row, column : INTEGER_16) : POINTER is
      external "C use <Table.h>"
      alias "TblGetItemPtr"
      end

   c_alias_last_usable_row (p : POINTER) : INTEGER_16 is
      external "C use <Table.h>"
      alias "TblGetLastUsableRow"
      end
   
   c_alias_number_of_columns( p : POINTER ) : INTEGER_16 is
      external "C use <Table.h>"
      alias "TblGetNumberOfColumns"
      end
   
   c_alias_number_of_rows (p : POINTER) : INTEGER_16 is
      external "C use <Table.h>"
      alias "TblGetNumberOfRows"
      end

   c_alias_row_data (p : POINTER; row : INTEGER_16) : INTEGER_32 is
      external "C use <Table.h>"
      alias "TblGetRowData"
      end

   c_alias_row_height (p : POINTER; row : INTEGER_16) : INTEGER_16 is
      external "C use <Table.h>"
      alias "TblGetRowHeight"
      end

   c_alias_row_id (p : POINTER; row : INTEGER_16) : INTEGER_16 is
      external "C use <Table.h>"
      alias "TblGetRowID"
      end

   c_alias_get_selection_base (p, p_row : POINTER; p_column : POINTER) : BOOLEAN is
      external "C use <Table.h>"
      alias "TblGetSelection"
      end

   c_alias_grab_focus (p : POINTER; row, column : INTEGER_16)  is
      external "C use <Table.h>"
      alias "TblGrabFocus"
      end

   c_alias_handle_event_base (p, p_event : POINTER) : BOOLEAN is
      external "C use <Table.h>"
      alias "TblHandleEvent"
      end

   c_alias_set_has_scroll_bar (p : POINTER; new_has_scroll_bar : BOOLEAN)  is
      external "C use <Table.h>"
      alias "TblHasScrollBar"
      end

   c_alias_insert_row (p : POINTER; row : INTEGER_16)  is
      external "C use <Table.h>"
      alias "TblInsertRow"
      end

   c_alias_mark_row_invalid (p : POINTER; row : INTEGER_16)  is
      external "C use <Table.h>"
      alias "TblMarkRowInvalid"
      end

   c_alias_mark_table_invalid (p : POINTER)  is
      external "C use <Table.h>"
      alias "TblMarkTableInvalid"
      end

   c_alias_redraw (p : POINTER)  is
      external "C use <Table.h>"
      alias "TblRedrawTable"
      end

   c_alias_release_focus (p : POINTER)  is
      external "C use <Table.h>"
      alias "TblReleaseFocus"
      end

   c_alias_remove_row (p : POINTER; row : INTEGER_16)  is
      external "C use <Table.h>"
      alias "TblRemoveRow"
      end

   c_alias_row_is_invalid (p : POINTER; row : INTEGER_16) : BOOLEAN is
      external "C use <Table.h>"
      alias "TblRowInvalid"
      end

   c_alias_row_is_masked (p : POINTER; row : INTEGER_16) : BOOLEAN is
      external "C use <Table.h>"
      alias "TblRowMasked"
      end

   c_alias_row_is_selectable (p : POINTER; row : INTEGER_16) : BOOLEAN is
      external "C use <Table.h>"
      alias "TblRowSelectable"
      end

   c_alias_row_is_usable (p : POINTER; row : INTEGER_16) : BOOLEAN is
      external "C use <Table.h>"
      alias "TblRowUsable"
      end

   c_alias_select_item (p : POINTER; row, column : INTEGER_16)  is
      external "C use <Table.h>"
      alias "TblSelectItem"
      end

   c_alias_set_column_edit_indicator (p : POINTER; 
				      column : INTEGER_16; 
				      new_in_edit_mode : BOOLEAN)  is
      external "C use <Table.h>"
      alias "TblSetColumnEditIndicator"
      end

   c_alias_set_column_masked (p : POINTER; 
			      column : INTEGER_16; 
			      new_is_masked : BOOLEAN)  is
      external "C use <Table.h>"
      alias "TblSetColumnMasked"
      end

   c_alias_set_column_spacing (p : POINTER; 
			       column, new_spacing : INTEGER_16 ) is
      external "C use <Table.h>"
      alias "TblSetColumnSpacing"
      end

   c_alias_set_column_is_usable (p : POINTER; 
				 column : INTEGER_16; 
				 new_is_usable : BOOLEAN)  is
      external "C use <Table.h>"
      alias "TblSetColumnUsable"
      end

   c_alias_set_column_width (p : POINTER; 
			     column, new_width : INTEGER_16 )  is
      external "C use <Table.h>"
      alias "TblSetColumnWidth"
      end

   c_alias_set_item_font (p : POINTER; 
			  row, column, new_font : INTEGER_16)  is
      external "C use <Table.h>"
      alias "TblSetItemFont"
      end

   c_alias_set_item_integer (p : POINTER; 
			     row, column, new_int : INTEGER_16)  is
      external "C use <Table.h>"
      alias "TblSetItemInt"
      end

   c_alias_set_item_pointer (p : POINTER; 
			     row, column : INTEGER_16; 
			     new_ptr : POINTER)  is
      external "C use <Table.h>"
      alias "TblSetItemPtr"
      end

   c_alias_set_item_style (p : POINTER; 
			   row, column, new_style : INTEGER_16 ) is
      external "C use <Table.h>"
      alias "TblSetItemStyle"
      end

   c_alias_set_row_data ( p : POINTER; 
			  row : INTEGER_16
			  new_data : INTEGER_32 )  is
      external "C use <Table.h>"
      alias "TblSetRowData"
      end

   c_alias_set_row_height (p : POINTER; 
			   row, new_height : INTEGER_16)  is
      external "C use <Table.h>"
      alias "TblSetRowHeight"
      end

   c_alias_set_row_id (p : POINTER; 
		       row, new_id : INTEGER_16)  is
      external "C use <Table.h>"
      alias "TblSetRowID"
      end

   c_alias_set_row_masked (p : POINTER; 
			   row : INTEGER_16; 
			   new_is_masked : BOOLEAN)  is
      external "C use <Table.h>"
      alias "TblSetRowMasked"
      end

   c_alias_set_row_is_selectable (p : POINTER; 
				  row : INTEGER_16; 
				  new_is_selectable : BOOLEAN)  is
      external "C use <Table.h>"
      alias "TblSetRowSelectable"
      end

   c_alias_set_row_static_height (p : POINTER; 
				  row, new_height : INTEGER_16)  is
      external "C use <Table.h>"
      alias "TblSetRowStaticHeight"
      end

   c_alias_set_row_is_usable (p : POINTER; 
			      row : INTEGER_16; 
			      new_is_usable : BOOLEAN)  is
      external "C use <Table.h>"
      alias "TblSetRowUsable"
      end

   c_alias_unhighlight_selection (p : POINTER)  is
      external "C use <Table.h>"
      alias "TblUnhighlightSelection"
      end


feature {ANY} -- aliased C features
   c_form_table_get_bounds (p_table, p_rectangle : POINTER)  is
      external "C use <Table.h>"
      alias "TblGetBounds"
      end

   c_form_table_current_field (p : POINTER) : POINTER is
      external "C use <Table.h>"
      alias "TblGetCurrentField"
      end

   c_form_table_item_bounds (p_table : POINTER; 
			     row, column : INTEGER_16; 
			     p_rectangle : POINTER)  is
      external "C use <Table.h>"
      alias "TblGetItemBounds"
      end

   c_tbl_set_bounds (p_table, p_rectangle : POINTER)  is
      external "C use <Table.h>"
      alias "TblSetBounds"
      end


feature {ANY} -- data features

feature {ANY} -- c_with_pointer features
   contains_row_with_data (data : INTEGER_32 ): BOOLEAN is
      local
	 row : INTEGER_16
      do
         Result := c_form_table_find_row_data( opaque_pointer, data, $row )
      end

   row_with_data (data : INTEGER_32 ) : INTEGER_16 is
      local
	 success : BOOLEAN
	 row : INTEGER_16
      do
         success := c_form_table_find_row_data( opaque_pointer, data, $row )
	 Result := row
      end

   contains_row_with_id (id : INTEGER_16) : BOOLEAN is
      local
	 row : INTEGER_16
      do
         Result := c_form_table_fond_row_id( opaque_pointer, id, $row )
      end

   row_with_id (id : INTEGER_16) : INTEGER_16 is
      local
	 success : BOOLEAN
	 row : INTEGER_16
      do
         success := c_form_table_row_with_id( opaque_pointer, id, $row )
	 Result := row
      end

   item_pointer_base_struct (row, column : INTEGER_16) : POINTER is
      local
	 offset : INTEGER_16
      do
	 offset := row * number_of_columns + column
         Result := c_form_table_item_pointer_base_struct( opaque_pointer, offset )
      end


feature {ANY} -- c_without_pointer features

feature {NONE} -- data feature support functions

feature {NONE} -- c_with_pointer feature support functions
   c_form_table_find_row_data( p: POINTER;
			       data : INTEGER_32;
			       p_row : POINTER ) : BOOLEAN is
      external "C use <Table.h>"
      alias "TblFindRowData"
      end
	 
   c_form_table_find_row_id_id ( p : POINTER; 
				       id : INTEGER_16; 
				       p_row : POINTER) : BOOLEAN is 
      external "C use <Table.h>"
      alias "TblFindRowID"
      end


   c_form_table_item_pointer_base_struct ( p : POINTER; offset : INTEGER_16 ) : POINTER is
      external "C use <Table.h>"
      alias "(((TablePtr)(p))->items[ offset ].ptr)"
      end


feature {NONE} -- c_without_pointer feature support functions

end
