indexing
   contents: "Memory access for moveable handles in PalmOS"
   author: "Victor Putz, vputz@nyx.net"
   completed: no
   tested: no

class MEM_HEAP
   
creation
   from_id, from_card_number_and_index
   
feature {ANY}   
   
   id : INTEGER_16
   
   last_error : INTEGER_16
   last_free_bytes : INTEGER_32
   last_max_free_chunk_size : INTEGER_32
   
   from_id( new_id : INTEGER_16 ) is 
      do
	 id := new_id
      end
   
   from_card_number_and_index( card_number, index : INTEGER_16 ) is
      do
	 id := c_mem_heap_id( card_number, index )
      end
   
   check_heap : INTEGER_16 is
      do
	 Result := c_mem_heap_check( id )
      end
   
   compact is
      do
	 c_mem_heap_compact( id )
      end
   
   is_dynamic : BOOLEAN is
      do
	 Result := c_mem_heap_dynamic( id )
      end
   
   flags : INTEGER_16 is
      do
	 Result := c_mem_heap_flags( id )
      end
   
   free_bytes : INTEGER_32 is
      do
	 last_error := c_mem_heap_free_bytes( id, 
				$last_free_bytes, 
				$last_max_free_chunk_size )
	 Result := last_free_bytes
	 --	 Result.set_value( c_mem_heap_free_bytes( id ) )
      end
   
   max_free_chunk_size : INTEGER_32 is
      do
	 c_mem_heap_free_bytes( id, 
				$last_free_bytes,
				$last_max_free_chunk_size )
	 Result := last_max_free_chunk_size
	 --	 Result.set_value( c_mem_heap_max_free_chunk_size( id ) )
      end
   
   scramble is
      do
	 c_mem_heap_scramble( id )
      end
   
   size : INTEGER_32 is
      do
	 Result := c_mem_heap_size( id )
      end
   
feature {NONE} -- C access
   
   c_mem_heap_id( card_number, index : INTEGER_16 ) : INTEGER_16 is 
      external "C use <MemoryMgr.h>" 
      alias "MemHeapID"
      end
   
   c_mem_heap_check( heap_id : INTEGER_16 ) : INTEGER_16 is 
      external "C use <MemoryMgr.h>" 
      alias "MemHeapCheck"
      end
   
   c_mem_heap_compact( heap_id : INTEGER_16 ) is 
      external "C use <MemoryMgr.h>" 
      alias "MemHeapCompact"
      end
   
   c_mem_heap_dynamic( heap_id : INTEGER_16 ) : BOOLEAN is 
      external "C use <MemoryMgr.h>" 
      alias "MemHeapDynamic"
      end
   
   c_mem_heap_flags( heap_id : INTEGER_16 ) : INTEGER_16 is 
      external "C use <MemoryMgr.h>" 
      alias "MemHeapFlags"
      end
   
   c_mem_heap_free_bytes( heap_id : INTEGER_16; 
			  pfree_bytes, 
			  pmax_chunk_size : POINTER ) : INTEGER_16 is 
      external "C use <MemoryMgr.h>" 
      alias "MemHeapFreeBytes"
      end
   
   --   c_mem_heap_max_free_chunk_size( heap_id : INTEGER_16 ) : POINTER is 
   --   external "C" 
   --   end
   
   c_mem_heap_scramble( heap_id : INTEGER_16 ) is 
      external "C use <MemoryMgr.h>" 
      alias "MemHeapScramble"
      end
   
   c_mem_heap_size( heap_id : INTEGER_16 ) : INTEGER_32 is 
      external "C use <MemoryMgr.h>" 
      alias "MemHeapSize"
      end
   
end

   
   
