

indexing
   contents: "generated wrapper for C type "
   author: "Victor B. Putz"
   completed: no
   tested: no
   

class SIMPLE_DATABASE_RECORD
   
feature {ANY} -- direct Eiffel features


   sizeof_uint32 : INTEGER_32 is 
      external "C inline"
      alias "(sizeof(uint32_t))"
      end
   
   sizeof_int16 : INTEGER_32 is 
      external "C inline"
      alias "(sizeof(int16_t))"
      end

   sizeof_character : INTEGER_32 is 
      external "C inline"
      alias "(sizeof(char))"
      end

   sizeof_string( s : STRING ) : INTEGER_32 is
	 --string size is length of string + 1 for trailing zero
      do
	 Result := s.count + 1
      end
   
   read_uint32( p : POINTER ) : INTEGER_32 is
      local
         i : INTEGER_32
      do
         c_dm_write( i.p_value, p, sizeof_uint32 )
         Result := i
      end

   write_uint32( p : POINTER; i : INTEGER_32 ) is
      do
         c_dm_write( p, i.p_value, sizeof_uint32 )
      end

   dm_write_uint32( p : POINTER; offset : INTEGER_32; i : INTEGER_32 ) is
      do
         c_dm_write( p, offset, i, sizeof_uint32 )
      end

   read_string( p : POINTER ) : STRING is
      do
	 create Result.from_external_copy( p )
      end
   
   write_string( p : POINTER; s : STRING ) is 
      do
	 c_dm_write( p, s.to_external, sizeof_string( s ) )
      end
   
   dm_write_string( p : POINTER; offset : INTEGER_32 ; s : STRING ) is
      do
	 c_dm_write( p, offset, s.to_external, sizeof_string( s ) )
      end	 
   
   read_from_handle( h : MEM_HANDLE ) is
      require
         not h.is_locked
      do
         h.lock
         read_from_pointer( h.locked_pointer )
         h.unlock
      end

   write_to_handle( h : MEM_HANDLE ) is
      require
         not h.is_locked
      do
         h.lock
         write_to_pointer( h.locked_pointer )
         h.unlock
      end

   dm_write_to_handle( h : MEM_HANDLE ) is
      require
	 not h.is_locked
      do
	 h.lock
	 dm_write_to_pointer( h.locked_pointer, 0 )
	 h.unlock
      end			
   
   dm_write_to_pointer( p : POINTER; starting_offset : INTEGER_32 ) is deferred end
			
   write_to_pointer( p : POINTER ) is deferred end
   
   read_from_pointer( p : POINTER ) is deferred end
   
   record_size : INTEGER_32 is deferred end

   

feature {ANY} -- structure features (aliased)

feature {ANY} -- aliased helper features for above

feature {ANY} -- aliased C features

feature {ANY} -- data features

feature {ANY} -- c_with_pointer features

feature {ANY} -- c_without_pointer features
   
   scratch_int16 : INTEGER_16
   
   scratch_character : CHARACTER
   
   read_int16 (p : POINTER) : INTEGER_16 is
      do
	 c_mem_move( $scratch_int16, p, sizeof_int16 )
	 Result := scratch_int16
      end

   write_int16 (p : POINTER; i : INTEGER_16)  is
      do
	 c_mem_move( p, $i, sizeof_int16 );
      end

   dm_write_int16 (p : POINTER; offset : INTEGER_32; i : INTEGER_16)  is
      do
	 scratch_int16 := i
	 c_dm_write( p, offset, $scratch_int16, sizeof_int16 )
      end

   read_character (p : POINTER) : CHARACTER is
      do
	 c_mem_move( $scratch_character, p, sizeof_character )
	 Result := scratch_character
      end

   write_character (p : POINTER; c : CHARACTER)  is
      do
	 c_mem_move( p, $c, sizeof_character )
      end

   dm_write_character (p : POINTER; offset : INTEGER_32; c : CHARACTER)  is
      do
	 scratch_character := c;
	 c_dm_write( p, offset, $scratch_character, sizeof_character )
      end

   pointer_plus (p : POINTER; i : INTEGER_32) : POINTER is
      do
	 Result := p + i;
      end

feature {NONE} -- data feature support functions

feature {NONE} -- c_with_pointer feature support functions

feature {NONE} -- c_without_pointer feature support functions
   c_mem_move( pdest, psource: POINTER; size : INTEGER_32 ) is
      external "C use <MemoryMgr.h>"
      alias "MemMove"
      end
   
   c_dm_write( p_dest: POINTER; offset : INTEGER_32; 
	       p_source: POINTER; size: INTEGER_32 ) is
      external "C use <MemoryMgr.h>"
      alias "DmWrite"
      end
   
end
