#!/usr/bin/ruby

$: << ENV["EPALM"] + "/tools"

# simple script; just take the arguments passed and add a few more
# items... and do some more target generation.

if ARGV.length > 0
  outfile = ARGV[ ARGV.index( "-o" ) + 1 ]
#  print "Outfile: #{outfile}\n"
  # now we'll create outfile.s and outfile.ld by using multigen
  print ( "Creating #{outfile}.s and #{outfile}.ld from #{outfile}.def\n" )
  system( "m68k-palmos-multigen #{outfile}.def" )
  # ok, now we have outfile-sections.ld and outfile-sections.s; now
  # we have to compile outfile-sections.s into outfile-sections.o
  print ( "Creating #{outfile}-sections.o from #{outfile}.s\n" )
  system( "m68k-palmos-gcc -c #{outfile}-sections.s" )
  # now insert the outfile.o and outfile.ld into the linking files
  index = ARGV.index( "-o" ) + 2
  argstring = ARGV[ 0..index ].join( " " ) + " #{outfile}-sections.o #{outfile}-sections.ld " + ARGV[ index+1..255 ].join( " " );
  #  print argstring + "\n"
  system( "m68k-palmos-gcc #{argstring}" )
  # now let's build the .bin files from the rcp file
  `pilrc #{outfile}.rcp`
  # OK, now our program is created (hopefully).  Let's try building a prc
  `build-prc #{outfile}.def -o #{outfile}.prc *.bin #{outfile}`
  # now remove the basic program file so that the PRC will be rebuilt every
  # time
  #if FileTest.exists?( "#{outfile}" )
  #  `rm #{outfile}`
  #end
end

