class Epalm_wizard
  
  attr_accessor :program_name, :program_title, :use_tables, :use_databases, :creator_id, :epalm_directory, :sdk_include_root

  def initialize
    @program_name = "main"
    @program_title = "Main"
    @use_tables = false
    @use_databases = false
  end

  def blank_file_text
"
Contents automatically generated by the epalm wizard script.
"
  end

  def makefile_am_text
    "
PROGNAME = #{@program_name}
noinst_PROGRAMS = $(PROGNAME)
CLEANFILES=*.bin *~ epalm_cecil.h
SmallEiffel=$(EPALM_SE)/system.se
#{@program_name}_SOURCES = $(PROGNAME)1.c
INCLUDES = $(SDK_INCLUDES) -I $(EPALM_INCLUDES)
LIBS = $(EPALM_LIBS)/libepalm.a
#{@program_name}_LDADD = app-sections.ld app-sections.o

all: $(PROGNAME).prc

$(PROGNAME)1.c $(PROGNAME).h : $(PROGNAME).e $(PROGNAME)_constants.e *.e
\texport SmallEiffel=$(SmallEiffel); \
\t$(SE_COMPILE_TO_C) -boost -cecil cecil.se $(PROGNAME) pilot_main
\t${RUBY} ${EPALM_TOOLS}/sectionize.rb ${PROGNAME}.h
\t${RUBY} ${EPALM_TOOLS}/strip_sprintf_pointer.rb ${PROGNAME}1.c

$(PROGNAME).prc : $(PROGNAME) bin.stamp
\tbuild-prc app.def -o ${PROGNAME}.prc *.bin ${PROGNAME}

app-sections.e : app-sections.s
\tm68-palmos-gcc -c app-sections.s

app-sections.s app-sections.ld : app.def
\tmultigen app.def

bin.stamp : $(PROGNAME).rcp
\t$(PILRC) $^

eiffelclean :
\t$(SE_CLEAN) $(PROGNAME)

$(PROGNAME)_constants.e : $(PROGNAME)_resource.h
\t${RUBY} ${EPALM_TOOLS}/make_constants.rb $(PROGNAME)_constants $(PROGNAME)_resource.h
"
  end

  def configure_in_text
"
dnl Process this file with autoconf to produce a configure script.
AC_INIT(Makefile.am)
AM_INIT_AUTOMAKE( #{@program_name}, 1.0 )
" + '
dnl Checks for programs.
AC_PATH_PROG(CC, m68k-palmos-gcc, no,$PATH:/usr/local/bin:\
/usr/local/m68k-palmos/bin:/usr/local/palm/m68k-palmos/bin)
if test "$CC" = "no"; then
        AC_MSG_ERROR("Unable to find m68k-palmos-gcc")
fi

AC_PATH_PROG(RANLIB, m68k-palmos-ranlib, no, $PATH:/usr/local/bin:\
/usr/local/m68k-palmos/bin:/usr/local/palm/m68k-palmos/bin )
if test "$RANLIB" = "no"; then
	AC_MSG_ERROR("Unable to find m68k-palmos-ranlib" )
fi

AC_PATH_PROG(AR, m68k-palmos-ar, no, $PATH:/usr/local/bin:\
/usr/local/m68k-palmos/bin:/usr/local/palm/m68k-palmos-bin )
if test "$AR" = "no"; then
	AC_MSG_ERROR("Unable to find m68k-palmos-ranlib" )
fi

AC_PATH_PROG(SE_COMPILE_TO_C, compile_to_c, no)
if test "$SE_COMPILE_TO_C" = "no"; then
	AC_MSG_ERROR("Unable to find SmallEiffel compile_to_c command")
fi

AC_PATH_PROG(SE_CLEAN, clean, no)
if test "$SE_CLEAN" = "no"; then
	AC_MSG_ERROR("Unable to find SmallEiffel clean command")
fi

AC_PATH_PROG(PILRC, pilrc)
if test "$PILRC" = "no"; then
	AC_MSG_ERROR("Unable to find pilrc resource compiler")
fi

AC_PATH_PROG(RUBY, ruby)
if test "$RUBY" = "no"; then
	AC_MSG_ERROR("Unable to find the Ruby interpreter")
fi

dnl Checks for libraries.

dnl Checks for header files.
AC_HEADER_DIRENT
AC_CHECK_HEADERS(unistd.h)

dnl Checks for typedefs, structures, and compiler characteristics.
AC_C_CONST
AC_TYPE_SIZE_T
AC_STRUCT_TM

dnl Checks for library functions.
AC_HEADER_STDC
AC_TYPE_SIGNAL
AC_CHECK_FUNCS(getcwd mkdir mktime rmdir)

dnl set epalm directory
AC_SUBST(EPALM)' + "
EPALM=#{@epalm_directory}
AC_SUBST(EPALM_TOOLS)
EPALM_TOOLS=$EPALM/tools
AC_SUBST(EPALM_INCLUDES)
EPALM_INCLUDES=$EPALM/src/include
AC_SUBST(EPALM_LIBS)
EPALM_LIBS=$EPALM/lib
AC_SUBST(EPALM_SE)
EPALM_SE=$EPALM/smalleiffel_sys

dnl set sdk include lines
AC_SUBST(SDK_INCLUDE_ROOT)
SDK_INCLUDE_ROOT=#{@sdk_include_root}
AC_SUBST(SDK_INCLUDES)
SDK_INCLUDES=-I\\ $SDK_INCLUDE_ROOT\\ -I\\ $SDK_INCLUDE_ROOT/Core\\ -I\\ $SDK_INCLUDE_ROOT/Core/System\\ -I\\ $SDK_INCLUDE_ROOT/Core/UI\\ -I\\ $SDK_INCLUDE_ROOT/Core/System/Unix\\ -I\\ $SDK_INCLUDE_ROOT/Core/Hardware
CFLAGS=-O2\\ -palmos3.1

AC_OUTPUT([ \\
Makefile \\
])
"
end

  def def_text
    "
application { \"#{@program_name}\" #{@creator_id} }
multiple code { btypes gc1 gc2 gc3 gc4 }
"
  end

  def base_class_text
    result = "
class #{@program_name.upcase}

inherit
   #{@program_name.upcase}_CONSTANTS
   FORM_DISPATCHER_CLIENT
   PALM_APPLICATION
      redefine
         handle_event, start_application
      end
"
if @use_tables then
  result << "   TABLE_DISPATCHER_CLIENT\n"
end
if @use_databases then
  result << "   DATABASE_MANAGER_CLIENT\n"
end
result << "

creation
   pilot_main

feature {ANY} -- redefined application features

   start_application is
      --opens main form
      do
         create form_handler
         form_manager.go_to_form( Main_form )
      end

   handle_event( event : EVENT ) is
      --handle PalmOS events
      local
         form : FORM
      do
         inspect event.type
         when Frm_load_event then
            create form.from_form_id( event.data_frmload_formid )
            form.set_as_active_form
            form.set_event_handler( form_handler )
            last_event_was_handled := True
         else
            last_event_was_handled := False
         end
      end

   form_handler : MAIN_FORM_EVENT_HANDLER

end -- class #{@program_name.upcase}
"
result
end

def loadpath_se_text
  "
./
#{@epalm_directory}/smalleiffel_sys/classes/
#{@epalm_directory}/src/application/
#{@epalm_directory}/src/structs/
#{@epalm_directory}/src/constants/
"
end

def main_form_class_text
  "
class MAIN_FORM_EVENT_HANDLER

inherit
   FORM_MANAGER_CLIENT
   #{@program_name.upcase}_CONSTANTS
   STANDARD_EVENT_HANDLER
      redefine
         handle_frm_open_event

feature {ANY}

   handle_frm_open_event( event : EVENT ) is
      do
         form_manager.active_form.draw
         last_event_was_handled := True
      end

end -- class MAIN_FORM_EVENT_HANDLER
"
end

def rcp_text
  "
#include \"#{@program_name}_resource.h\"

FORM ID Main_form AT (0 0 160 160)
BEGIN
    TITLE \"Main Form\"
END
"
end

def resource_h_text
  "
#define Main_form                1000
"
end

def cecil_se_text
  result = "
--the name of the includable C file
epalm_cecil.h
--the features you want to call from C
FORM_DISPATCHER_dispatch_event_from_pointer FORM_DISPATCHER dispatch_event_from_pointer
FORM_DISPATCHER_CLIENT_form_dispatcher FORM_DISPATCHER_CLIENT form_dispatcher
"
  if @use_tables then
    result << "TABLE_DISPATCHER_CLIENT_table_dispatcher TABLE_DISPATCHER_CLIENT table_dispatcher
TABLE_DISPATCHER_dispatch_custom_save_data_event TABLE_DISPATCHER dispatch_custom_save_data_event
TABLE_DISPATCHER_dispatch_custom_load_data_event TABLE_DISPATCHER dispatch_custom_load_data_event
TABLE_DISPATCHER_dispatch_custom_draw_event TABLE_DISPATCHER dispatch_custom_draw_event
"
  end

  if @use_databases then
    result << "DATABASE_MANAGER_compare_database_records DATABASE_MANAGER compare_database_records
DATABASE_MANAGER_CLIENT_database_manager DATABASE_MANAGER_CLIENT database_manager"
  end
  result
end

end


def print_to_file( filename, text )
  print "Creating #{filename}...\n"
  File.open( filename, "w" ) { |f|
    f.puts( text )
  }
end

w = Epalm_wizard.new
print "Welcome to the very simple ePalm project wizard.\n"
print "Please answer the following questions:\n"
print "Enter the project's name (one word, all lowercase): "
w.program_name = gets.downcase.chop!
print "Enter the project's title (in the PalmOS menu): "
w.program_title = gets.downcase.chop!
print "Enter the program's creator ID (four charecters): "
w.creator_id = gets.downcase.chop!
print "Enter the ePalm root directory:"
w.epalm_directory = gets.downcase.chop!
print "Enter the root directory of the SDK include files:"
w.sdk_include_root = gets.downcase.chop!
print "Will the project use tables? "
w.use_tables = ((gets.downcase)[0,1] == 'y' )
print "Will the project use database management? "
w.use_databases = ((gets.downcase)[0,1] == 'y' )
print "About to create project files in the current directory\nProceed? "
if ((gets.downcase)[0,1] == 'y' ) then
  print_to_file( "configure.in", w.configure_in_text )
  print_to_file( "Makefile.am", w.makefile_am_text )
  print_to_file( "app.def", w.def_text )
  print_to_file( "#{w.program_name}.e", w.base_class_text )
  print_to_file( "main_form_event_handler.e", w.main_form_class_text )
  print_to_file( "#{w.program_name}.rcp", w.rcp_text )
  print_to_file( "#{w.program_name}_resource.h", w.resource_h_text )
  print_to_file( "cecil.se", w.cecil_se_text )
  print_to_file( "loadpath.se", w.loadpath_se_text )
  print_to_file( "NEWS", w.blank_file_text )
  print_to_file( "README", w.blank_file_text )
  print_to_file( "COPYING", w.blank_file_text )
  print_to_file( "AUTHORS", w.blank_file_text )
  print_to_file( "ChangeLog", w.blank_file_text )
  print "Using aclocal to generate aclocal.m4...\n"
  `aclocal`
  print "Using autoconf to generate configure...\n"
  `autoconf`
  print "Using automake to generate Makefile.in...\n"
  `automake --add-missing`
  print "configuring and creating makefile...\n"
  `./configure`
end

