
def eiffel_constant_name_from_other_case_name( name )
  a = name.gsub( /[A-Z]/ ) { |s| "_" + s.downcase }
  a.gsub!( /^_/, "" )
  a.gsub( /^[a-z]/ ) { |s| s.upcase }
end

def eiffel_line_from_header_line( line )
  r = Regexp.compile( '^#define\s*([A-Za-z_]*)\s*(\S*)' )
  match = r.match( line )
  if match != nil
    test = match[2].clone
    if test =~ /0x[0-9a-fA-F]*/
      right_half = match[2].hex.to_s
    elsif test =~ /[0-9]*/
      right_half = match[2]
    end
    "   #{eiffel_constant_name_from_other_case_name(match[1])} : INTEGER_16 is #{right_half}\n"
  else 
    ""
  end
end

def class_header( class_name )
  "class #{class_name.upcase}\n\nfeature {ANY} -- constants\n\n"
end

def class_file_text_from_header_file_lines( class_name, header_file_lines )
  result = class_header( class_name );
  header_file_lines.each { |line|
    result += eiffel_line_from_header_line( line )
  }
  result += "\nend\n"
  result
end

def class_file_text_from_header_file( class_name, header_file_name )
  header_file_lines = IO.readlines( header_file_name )
  class_file_text_from_header_file_lines( class_name, header_file_lines )
end  

if ARGV.length == 2
  File.open( ARGV[0].downcase + ".e", "w" ) { |outfile|
    outfile.write( class_file_text_from_header_file( ARGV[0], ARGV[1]) )
  }
else
    print "Wrong number of arguments\n\nUsage: make_constants class_name header_file\n\n"
end



