module Replace_gc_sizes

  def Replace_gc_sizes.replace_gc_sizes( lines )
    rsoc_pattern = /#define RSOC_SIZE [0-9]+/
    fsoc_pattern = /#define FSOC_SIZE [0-9]+/
    lines.each { |line|
      line.gsub!( rsoc_pattern, "#define RSOC_SIZE 4096" )
      line.gsub!( fsoc_pattern, "#define FSOC_SIZE 1024" )
    }
  end

  def Replace_gc_sizes.replace_gc_sizes_by_filename( filename )
    lines = IO.readlines( filename )
    replace_gc_sizes( lines )
    File.open( filename, "w" ) { |outfile|
      outfile.write( lines )
    }
  end


end
