#strips the offending "%p" and replaces it with a more PalmOS-friendly "%ld"
#for pointer sprintf conversions

def stripped_file_from_filename( filename )
  lines = IO.readlines( filename )
  stripped_file_from_lines( lines )
end

def strip_sprintf_pointer( lines )
  lines.each { |line|
    if line =~ /\"%p\"/
      line.gsub!( /\"%p\"/, "\"%ld\"" )
    end
  }
end

def stripped_file_from_lines( lines )
  strip_sprintf_pointer( lines )
end

if ARGV.length == 1
  newlines = stripped_file_from_filename( ARGV[0] )
  File.open( ARGV[0], "w" ) {
    |outfile|
    outfile.write( newlines )
  }
end

